// Card.cpp: implementation of the CCard class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "define.h"
#include "MemoKing.h"
#include "Card.h"
#include "Template.h"
#include <stdlib.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCard::CCard(DWORD dwMemorizingRate)
{
	for (int i = 0 ; i < MAX_ITEM; i++)
		m_strWord[i].Empty();

	m_dwMemorizingRate = dwMemorizingRate;
}

bool CCard::SetWord(UINT nIndex, LPCTSTR szWord)
{
	ASSERT(nIndex < MAX_ITEM);

	if (IsNeedUpdate(nIndex, szWord) == true)
	{
		m_strWord[nIndex] = szWord;
		return true;
	}
	else
		return false;
}

/******* [ȯ] GetParsedWord()  ***/
CString CCard::GetParsedWord(UINT nIndex, UINT nParseIndex) const
{
	ASSERT(nIndex < MAX_ITEM);
	CString str = m_strWord[nIndex];
	UINT pos = 0;	//  Ž ġ 
	UINT count = 0;	//  Ž ܾ .
	int res = 0;	// ˻ ȯ.

	// 1) ش word ãư.
	while( count < nParseIndex ) {
		res = str.Find(_T(","), pos);
		if( res == -1 )
			return CString(_T("No Word"));	//  쿡 ܾ شϴ ڰ  .
		pos = res + 1;
		count++;
	}

	// 2) ܾ иس.
	if( (res = str.Find(_T(","), pos)) == -1 ) {
		//  ̻ ,   .
		return str.Mid(pos);
	} else {
		// Ŀ ,  .
		return str.Mid(pos, (res-pos));
	}

}
/******* [ȯ] GetParsedWord()  ***/

/******* [ȯ] GetParsedWordCount()  ***/
int CCard::GetParsedWordCount(UINT nIndex) const
{
	ASSERT(nIndex < MAX_ITEM);
	CString str = m_strWord[nIndex];
	int count = 0;
	int pos = 0;
	int res;

	while( (res = str.Find(_T(","), pos )) != -1) {
		pos = res + 1;
		count++;
	}

	return count+1;
}
/******* [ȯ] GetParsedWordCount()  ***/

bool CCard::IsNeedUpdate(UINT nIndex, LPCTSTR szNewWord) const
{
	ASSERT(nIndex < MAX_ITEM);

	if (szNewWord == NULL) 
	{
		if (m_strWord[nIndex].IsEmpty()) //Ѵ NULL  
			return false;
		else //ִ ڿ   
			return true;
	}
	else
	{
		if (m_strWord[nIndex].IsEmpty()) //     ϴ  
			return true;
		else //Ѵ NULL ƴ  
		{
			return (_tcscmp(m_strWord[nIndex], szNewWord) != 0);
		}
	}
}

bool CCard::IsIncludeWord(LPCTSTR szWord) const
{
	for (UINT i = 0 ; i < MAX_ITEM; i++)
	{
		if (IsIncludeWord(szWord, i) == true)
			return true;
	}
	return false;
}

bool CCard::IsIncludeWord(LPCTSTR szWord, UINT uiItemIndex) const
{
	if (m_strWord[uiItemIndex].Find(szWord) >= 0)
		return true;
	else
		return false;
}

void CCard::SaveToFile(CFile* pFile) const
{
	pFile->Write((void*)&m_dwMemorizingRate, sizeof(DWORD));
	DWORD dwWordLen;
	for (UINT nIndex = 0; nIndex < MAX_ITEM; nIndex++)
	{
		dwWordLen = _tcslen(m_strWord[nIndex]);
		pFile->Write((void*)&dwWordLen, sizeof(DWORD));
		if (dwWordLen > 0)
			pFile->Write((void*)((LPCTSTR)m_strWord[nIndex]), sizeof(TCHAR) * dwWordLen);
	}
}

void CCard::SaveToFile(HANDLE hFile) const
{
	DWORD dwWritten;

	WriteFile(hFile, (void*)&m_dwMemorizingRate, sizeof(DWORD), &dwWritten, NULL);

	DWORD dwWordLen;
	for (UINT nIndex = 0; nIndex < MAX_ITEM; nIndex++)
	{
		dwWordLen = _tcslen(m_strWord[nIndex]);
		WriteFile(hFile, (void*)&dwWordLen, sizeof(DWORD), &dwWritten, NULL);
		if (dwWordLen > 0)
			WriteFile(hFile, (void*)((LPCTSTR)m_strWord[nIndex]), sizeof(TCHAR) * dwWordLen, &dwWritten, NULL);
	}
}

CCardSet::CCardSet()
{
	m_nCardIndex = 0;
	m_nMemorized = 0;
	m_bModified = false;
	m_posList = NULL;  
	m_posRandomList = NULL;
	m_posBookmark = NULL;
}

CCardSet::~CCardSet()
{
	POSITION posCardList = m_lstCard.GetHeadPosition();
	CCard* pCard;
	for (int i = 0; i < m_lstCard.GetCount(); i++)
	{
		pCard = m_lstCard.GetNext(posCardList);
		if (pCard != NULL)
		{
			delete pCard;
			pCard = NULL;
		}
	}
}

void CCardSet::AddCardToTail(CCard* pCard)
{
	ASSERT(pCard != NULL);
	m_lstCard.AddTail((CCard*)pCard);
	m_bModified = true;
}

void CCardSet::InsertCard(CCard* pCard)
{
	ASSERT(pCard != NULL);
	if (m_posList != NULL)
		m_posList = m_lstCard.InsertBefore(m_posList, pCard);
	else
		m_posList = m_lstCard.AddTail(pCard);
	m_bModified = true;
}

void CCardSet::DeleteCurrentCard()
{
	if (m_posList != NULL)
	{
		CCard* pCard = m_lstCard.GetAt(m_posList);

		ASSERT(pCard != NULL);

		delete pCard;
		POSITION posDelete = m_posList;
		if (m_lstCard.GetTailPosition() == posDelete)
		{
			m_lstCard.RemoveAt(posDelete);
			m_posList = m_lstCard.GetHeadPosition();
			m_nCardIndex = 0;
		}
		else
		{
			m_lstCard.GetNext(m_posList);
			m_lstCard.RemoveAt(posDelete);
		}
		
		m_bModified = true;
	}
}


//īϿ Random ī带 ̾Ƴ.
CCard* CCardSet::GetRandomCard() const
{
	int nIndex = rand() % m_lstCard.GetCount();

	POSITION posCard = m_lstCard.FindIndex(nIndex);
	return (CCard*)m_lstCard.GetAt(posCard);
}

CCard* CCardSet::GetCardFromIndex(int nIndex) const
{
	ASSERT(nIndex >= 0 && nIndex < m_lstCard.GetCount());
	POSITION posCard = m_lstCard.FindIndex(nIndex);
	return (CCard*)m_lstCard.GetAt(posCard);
}

CCard* CCardSet::GetCardFromList(bool bMemorized)
{
	if (bMemorized == true) //ϱ ī带 ã  
	{
		if (m_nMemorized == 0)
			return NULL;
	}
	else //ϱ  ī带 ã 
	{
		if (m_nMemorized == m_lstCard.GetCount())
			return NULL;
	}

	CCard* pSelectCard;

	bool bFound = false;
	while(bFound == false)
	{
		pSelectCard = (CCard*)m_lstCard.GetAt(m_posList);
		if (pSelectCard->IsMemorized() == bMemorized)
			bFound = true;
		m_lstCard.GetNext(m_posList);
		m_nCardIndex++;
		if (m_posList == NULL)
		{
			m_posList = m_lstCard.GetHeadPosition();
			m_nCardIndex = 0;
		}
	}

	return pSelectCard;
}

CCard* CCardSet::GetCardFromRandomList(bool bMemorized) 
{
	if (bMemorized == true) //ϱ ī带 ã  
	{
		if (m_nMemorized == 0)
			return NULL;
	}
	else //ϱ  ī带 ã 
	{
		if (m_nMemorized == m_lstCard.GetCount())
			return NULL;
	}

	if (m_posRandomList == NULL)
		MakeRadomCardList();

	CCard* pSelectCard;

	bool bFound = false;
	while(bFound == false)
	{
		pSelectCard = (CCard*)m_lstRandomCard.GetAt(m_posRandomList);
		if (pSelectCard->IsMemorized() == bMemorized)
			bFound = true;
		m_lstRandomCard.GetNext(m_posRandomList);
		if (m_posRandomList == NULL)
			MakeRadomCardList();
	}

	return pSelectCard;
}

void CCardSet::MakeRadomCardList()
{
	m_lstRandomCard.RemoveAll();
	CARD_LIST lstCardTemp; 

	//Copy the master list
	POSITION posCardList = m_lstCard.GetHeadPosition();
	CCard* pCard;
	for (int i = 0; i < m_lstCard.GetCount(); i++)
	{
		pCard = m_lstCard.GetNext(posCardList);
		lstCardTemp.AddTail(pCard);
	}

	//Make the random list
	int nIndex;
	POSITION posCard;

	while(lstCardTemp.GetCount() > 0)
	{
		nIndex = rand() % lstCardTemp.GetCount();

		posCard = lstCardTemp.FindIndex(nIndex);
		pCard = (CCard*)lstCardTemp.GetAt(posCard);
		m_lstRandomCard.AddTail(pCard);
		lstCardTemp.RemoveAt(posCard);
	}

	m_posRandomList = m_lstRandomCard.GetHeadPosition();
}

void CCardSet::MoveToFirst()
{
	m_posList = m_lstCard.GetHeadPosition();
	m_nCardIndex = 0;
}

void CCardSet::MoveToLast()
{
	m_posList = m_lstCard.GetTailPosition();
	m_nCardIndex = m_lstCard.GetCount() -1;
}

void CCardSet::MoveToPosition(POSITION posCard)
{
	ASSERT(posCard != NULL);
	m_posList = posCard;
	m_nCardIndex = GetIndexFromPosition(m_posList);
}


void CCardSet::MoveToIndex(int nIndex)
{
	ASSERT(nIndex >= 0 && nIndex <= m_lstCard.GetCount());
	m_nCardIndex = nIndex;
	m_posList = m_lstCard.FindIndex(nIndex); 
}

bool CCardSet::MoveNext()
{
	m_lstCard.GetNext(m_posList);
	m_nCardIndex++;
	if (m_posList == NULL)
		return false;
	else
		return true;
}

bool CCardSet::MovePrev()
{
	m_lstCard.GetPrev(m_posList);
	m_nCardIndex--;
	if (m_posList == NULL)
		return false;
	return true;
}

bool CCardSet::IsLastCard() const
{
	if (m_posList == m_lstCard.GetTailPosition())
		return true;
	else
		return false;
}

bool CCardSet::IsFirstCard() const
{
	if (m_posList == m_lstCard.GetHeadPosition())
		return true;
	else
		return false;
}

void CCardSet::ResetMemorizing()
{
	POSITION posCardList = m_lstCard.GetHeadPosition();
	CCard* pCard;
	for (int i = 0; i < m_lstCard.GetCount(); i++)
	{
		pCard = m_lstCard.GetNext(posCardList);
		if (pCard != NULL)
		{
			pCard->Reset();
		}
	}
	m_nMemorized = 0;
}

CCard* CCardSet::GetCard() const
{
	if (m_posList != NULL)
		return m_lstCard.GetAt(m_posList);
	else
		return NULL;
}

int CCardSet::GetBookmarkIndex() const
{
	if (m_posBookmark != NULL)
		return GetIndexFromPosition(m_posBookmark);
	else
		return -1;
}

void CCardSet::SetBookmark(int nIndex)
{
	m_posBookmark = m_lstCard.FindIndex(nIndex); 
}

int CCardSet::GetCurrentPosIndex() const
{
	return GetIndexFromPosition(m_posList);
}

void CCardSet::SetCurrentPos(int nIndex)
{
	m_posList = m_lstCard.FindIndex(nIndex);
	m_nCardIndex = nIndex;
}

int CCardSet::GetIndexFromPosition(POSITION posFind) const
{
	int nCardIndex = 0;
	BOOL bFound = FALSE;
	POSITION posCardList = m_lstCard.GetHeadPosition();
	for (int i = 0; i < m_lstCard.GetCount(); i++)
	{
		if (posFind == posCardList)
		{
			bFound = TRUE;
			break;
		}
		m_lstCard.GetNext(posCardList);
		nCardIndex++;
	}

	if (bFound != TRUE)
		nCardIndex = -1;
	return nCardIndex;
}


void CCardSet::SaveToFile(CFile* pFile) const
{
	ASSERT(pFile != NULL);

	POSITION posCardList = m_lstCard.GetHeadPosition();
	CCard* pCard;
	for (int i = 0; i < m_lstCard.GetCount(); i++)
	{
		pCard = m_lstCard.GetNext(posCardList);
		pCard->SaveToFile(pFile);
	}
}

void CCardSet::SaveToFile(HANDLE hFile) const
{
	ASSERT(hFile != NULL);

	POSITION posCardList = m_lstCard.GetHeadPosition();
	CCard* pCard;
	for (int i = 0; i < m_lstCard.GetCount(); i++)
	{
		pCard = m_lstCard.GetNext(posCardList);
		pCard->SaveToFile(hFile);
	}
}

bool CCardSet::SaveToTextFile(CFile* pFile, bool bUnicode) const
{
	ASSERT(pFile != NULL);

	//ڵ ؽƮ 
	if (bUnicode == true)
	{
		BYTE pBuffer[2];
		pBuffer[0] = 0xFF;
		pBuffer[1] = 0xFE;
		pFile->Write(pBuffer, 2);
	}

	POSITION posCardList = m_lstCard.GetHeadPosition();
	CCard* pCard;
	LPCTSTR szWord;
	CString strLine;
	for (int i = 0; i < m_lstCard.GetCount(); i++)
	{
		pCard = m_lstCard.GetNext(posCardList);
		strLine = _T("");
		for (UINT nIndex = 0; nIndex < MAX_ITEM; nIndex++)
		{
			szWord = pCard->GetWord(nIndex);
			if (lstrlen(szWord) > 0)
				strLine += szWord;
			strLine += _T(" // ");
		}

		int nLength;
		while(TRUE)
		{
			//ڿ ʿ //ǥø Ѵ.
			nLength = strLine.GetLength();
			if (strLine.Right(4) == _T(" // "))
				strLine = strLine.Mid(0, nLength - 4);
			else
				break;
		}

		strLine += _T("\r\n");
		if (bUnicode == true)
			pFile->Write((LPCTSTR)strLine, sizeof(TCHAR) * strLine.GetLength());
		else
		{
			char szBuffer[1024];
			wcstombs(szBuffer, (LPCTSTR)strLine, 1024);
			pFile->Write(szBuffer, sizeof(char) * strlen(szBuffer));
		}
	}
	return true;
}


bool CCardSet::LoadFromFile(CFile* pFile, DWORD dwNumCards)
{
	CCard* pCard;
	DWORD dwWordLen;
	TCHAR szWord[1024];
	DWORD dwRate;
	DWORD dwRead;
	for (DWORD i = 0; i < dwNumCards; i++)
	{
		dwRead = pFile->Read((void*)&dwRate, sizeof(DWORD));
		if (dwRead != sizeof(DWORD))
		{
			return false;
		}
		pCard = new CCard(dwRate);
		if (dwRate != 0)
			m_nMemorized++;
		for (UINT nIndex = 0; nIndex < MAX_ITEM; nIndex++)
		{
			dwRead = pFile->Read((void*)&dwWordLen, sizeof(DWORD));
			if (dwRead != sizeof(DWORD))
			{
				delete pCard;
				return false;
			}
			if (dwWordLen > 0)
			{
				dwRead = pFile->Read((void*)szWord, sizeof(TCHAR) * dwWordLen);
				if (dwRead != sizeof(TCHAR) * dwWordLen)
				{
					delete pCard;
					return false;
				}
				szWord[dwWordLen] = _T('\0');
				pCard->SetWord(nIndex, szWord);
			}
		}
		AddCardToTail(pCard);
	}
	m_bModified = false;

	return true;
}

POSITION CCardSet::FindCard(LPCTSTR szFind, bool bSelectItemOnly, UINT nSelectItem, bool bMove)
{
	// ġ   ãƺ.
	CCard* pCard;
	bool bFound;
	POSITION posStart = m_posList;
	POSITION posList = m_posList;
	POSITION posFind = NULL;

	m_lstCard.GetNext(posList);
	if (posList == NULL)
		posList = m_lstCard.GetHeadPosition();
	while(posFind == NULL)
	{
		pCard = m_lstCard.GetAt(posList);
		if (bSelectItemOnly == true)
			bFound = pCard->IsIncludeWord(szFind, nSelectItem);
		else
			bFound = pCard->IsIncludeWord(szFind);

		if (bFound == true)
			posFind = posList;
		else
		{
			// ī ̵ 
			m_lstCard.GetNext(posList);
			if (posList == NULL)
				posList = m_lstCard.GetHeadPosition();
			else
			{
				if (posList == posStart) //ó ġ   
					break;
			}
		}
	}

	if (bMove == true && posFind != NULL)
		MoveToPosition(posFind);

	return posFind;
}

