// CardFile.h: interface for the CCardFile class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CARDFILE_H__3DFD811B_747F_416C_9459_81465B097CDC__INCLUDED_)
#define AFX_CARDFILE_H__3DFD811B_747F_416C_9459_81465B097CDC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef struct _CARDSET_HEADER
{
	WORD wType;    //Type
	WORD wVersion; //File Version
	DWORD dwNumCards; //Card  
} CARDSET_HEADER;

typedef struct _CARDSET_HEADER_EX
{
	int nBookmark; //ϸũ ġ
	int nCurPos;   //ä ġ 
	DWORD dwReserved1;
	DWORD dwReserved2;
} CARDSET_HEADER_EX;

class CCardSet;
class CTemplate;
class CQuizSetting;

class CCardFile  
{
private:
	static bool ExtractLine(char* pBuffer, UINT& nIndex, bool bEOF, CString& strLine);
	static bool ExtractLineU(char* pBuffer, UINT& nIndex, bool bEOF, CString& strLine);
	static bool ProcessStringLine(CCardSet* pCardSet, CString& strLine, LPCTSTR szSep);
	static bool CheckSeperator(LPCTSTR szFileName, bool bUnicode, CString& strSep);
	
public:
	CCardFile();
	virtual ~CCardFile();
	
	static bool ImportTextFile(LPCTSTR szFileName, CCardSet* pCardSet);
	static bool ImportAsciiTextFile(LPCTSTR szFileName, CCardSet* pCardSet, LPCTSTR szSep);
	static bool ImportUnicodeTextFile(LPCTSTR szFileName, CCardSet* pCardSet, LPCTSTR szSep);
	static bool SaveFile(LPCTSTR szFileName, const CCardSet* pCardSet, const CTemplate* pTemplate, const CQuizSetting* pQuizSetting);
	static bool SaveFile2(LPCTSTR szFileName, const CCardSet* pCardSet, const CTemplate* pTemplate, const CQuizSetting* pQuizSetting);
	static bool SaveHeader(LPCTSTR szFileName, const CCardSet* pCardSet);
	static bool LoadFile(LPCTSTR szFileName, CCardSet* pCardSet, CTemplate* pTemplate, CQuizSetting* pQuizSetting);
	static bool ExportToTextFile(LPCTSTR szFileName, CCardSet* pCardSet, bool bUnicode);
};

#endif // !defined(AFX_CARDFILE_H__3DFD811B_747F_416C_9459_81465B097CDC__INCLUDED_)
