// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include <Commdlg.h>
#include "define.h"
#include "MemoKing.h"
#include "Card.h"
#include "Template.h"
#include "Quiz.h"
#include "ChildView.h"
#include "EditCardDlg.h"
#include "TemplateSetupDlg.h"
#include "GotoCardDlg.h"
#include "StrokeView.h"
#include "QuizSetupDlg.h"
#include "OptionDlg.h"
#include "DlgAutoProgress.h"
#include "Utils.h"
#include "FindDlg.h"
#include "MainFrm.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define ID_TIMER_LIMIT 1000
#define ID_TIMER_AUTO_PROGRESS 1001

#define TIMER_WIDTH    30
#define TIMER_HEIGHT  28
#define TIMER_Y_POS CLIENT_AREA_HEIGHT - TIMER_HEIGHT

extern PROGRAM_MODE g_ProgramMode;
extern CCardSet* g_pCardSet;
extern CTemplate* g_pTemplate;
extern CString g_strCardFile;
extern CQuizSetting* g_pQuizSetting;
extern CMainFrame* h_main;				// 2007-02-03 Edit control   ߰..

BOOL ConvertNewLine(CString& strWord);

/////////////////////////////////////////////////////////////////////////////
// CChildView

CChildView::CChildView()
{
	m_bWordWrap = TRUE;
	m_bQuestion = TRUE;
	m_bShowStrokeView = TRUE;
	m_bShowDictionaryView = FALSE;			// 2007-02-02 ߰
	m_bShowStatusIcon = TRUE;
	m_bSeqMemoMode = FALSE;
	m_uiTimerLimit = 0;
	m_uiTimerCount = 0;

	m_dwButtonSize = BUTTON_HEIGHT;

	m_pQuizList = new CQuizList();
	m_pStrokeView = new CStrokeView();

	m_rgbBack = RGB(255, 255, 255);
	m_bAutoRepeat = TRUE;
	m_bAutoProgress = FALSE;

	m_pCurrentCard = NULL;

	for (UINT i = 0; i < MAX_ITEM; i++)
		m_pEditItem[i] = NULL;
	
}

CChildView::~CChildView()
{
	if (m_pQuizList != NULL)
	{
		delete m_pQuizList;
		m_pQuizList = NULL;
	}
	if (m_pStrokeView != NULL)
	{
		delete m_pStrokeView;
		m_pStrokeView = NULL;
	}
}


BEGIN_MESSAGE_MAP(CChildView,CWnd )
	//{{AFX_MSG_MAP(CChildView)
	ON_WM_PAINT()
	ON_WM_CREATE()
	ON_WM_LBUTTONDOWN()
	ON_COMMAND(ID_TIMER_10SEC, OnTimer10sec)
	ON_COMMAND(ID_TIMER_20SEC, OnTimer20sec)
	ON_COMMAND(ID_TIMER_30SEC, OnTimer30sec)
	ON_COMMAND(ID_TIMER_5SEC, OnTimer5sec)
	ON_COMMAND(ID_TIMER_60SEC, OnTimer60sec)
	ON_COMMAND(ID_TIMER_UNLIMIT, OnTimerUnlimit)
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_COMMAND(ID_EDIT_CARD, OnEditCard)
	ON_COMMAND(ID_ITEM_ATTR, OnItemAttr)
	ON_COMMAND(ID_STROKE_VIEW, OnStrokeView)
	ON_COMMAND(ID_DICTIONARY_VIEW, OnDictionaryView)		// 2007-02-02 ߰
	ON_COMMAND(ID_DEL_CARD, OnDelCard)
	ON_COMMAND(ID_ADD_CARD, OnAddCard)
	ON_COMMAND(ID_MOVE_CARD, OnMoveCard)
	ON_COMMAND(ID_ADD_BOOKMARK, OnAddBookmark)
	ON_WM_SIZE()
	ON_COMMAND(ID_SETUP_QUIZ, OnSetupQuiz)
	ON_WM_ERASEBKGND()
	ON_COMMAND(ID_OPTIONS, OnOptions)
	ON_COMMAND(ID_AUTO_PROGRESS, OnAutoProgress)
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_COMMAND(ID_EDIT_FIND, OnEditFind)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.style &= ~WS_BORDER;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW, 
		NULL, HBRUSH(COLOR_WINDOW+1), NULL);

	return TRUE;
}

void CChildView::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	// 2007-02-01 paint ̷   ٽ ش.
	this->SetFocus();
	for (UINT i = 0; i < MAX_ITEM; i++)
	{
		if( m_pEditItem[i] != NULL )
		{
			delete m_pEditItem[i];			// initialize
			m_pEditItem[i] = NULL;
		}
	}

	if (m_pCurrentCard != NULL)
	{
		int yStart = STATUS_BAR_HEIGHT + 2;
		
		if (g_ProgramMode == QUIZ_MODE) 
		{
			if (m_bQuestion == FALSE)
				DrawQuizResult(&dc, yStart);

			DrawCard(&dc, m_pQuizList->GetQuiz()->GetQuizCard(), yStart);
			DrawExample(&dc, yStart);
		}
		else
		{
			DrawCard(&dc, m_pCurrentCard, yStart);
		}

		if (g_ProgramMode != STUDY_MODE && m_uiTimerLimit != 0 
			&& m_bAutoProgress == FALSE) //н 尡 ƴϸ 
		{
			DrawCounter(&dc);
		}

		m_pStrokeView->OnPaint(&dc);
		DrawStatus(&dc);
	}

}


void CChildView::DrawCounter(CDC* pDC)
{
	int nOldMode = pDC->SetBkMode(TRANSPARENT);
	COLORREF crOldText = pDC->SetTextColor(RGB(255, 128, 128));
	CFont* pOldFont = pDC->SelectObject(&m_fntTimerLimit);

	CString strCounter;
	strCounter.Format(_T("%d"), m_uiTimerCount);
	CRect rcClient;
	GetClientRect(&rcClient);

	CRect rcCounter;
	rcCounter.left = rcClient.Width() - 4 - TIMER_WIDTH;
	//rcCounter.top = TIMER_Y_POS;
	rcCounter.top = rcClient.Height() - TIMER_HEIGHT;
	rcCounter.right = rcCounter.left + TIMER_WIDTH;
	rcCounter.bottom = rcCounter.top + TIMER_HEIGHT;
	pDC->DrawText(strCounter, rcCounter, DT_RIGHT);

	pDC->SelectObject(pOldFont);
	pDC->SetTextColor(crOldText);
	pDC->SetBkMode(nOldMode);
}

void CChildView::DrawStatus(CDC* pDC)
{
	if (g_pCardSet->GetNumCards() == 0)
		return;

	CRect rcClient;
	GetClientRect(&rcClient);
	//Box
	CBrush brushBlue(RGB(128, 128, 255));
	CBrush* pOldBrush = pDC->SelectObject(&brushBlue);

	// Create and select a thick, black pen.
	CPen penBlack;
	penBlack.CreatePen(PS_SOLID, 1, RGB(0, 0, 0));
	CPen* pOldPen = pDC->SelectObject(&penBlack);
	
	pDC->Rectangle(0, 0, rcClient.Width(), STATUS_BAR_HEIGHT);

	// Put back the old objects.
	pDC->SelectObject(pOldBrush);
	pDC->SelectObject(pOldPen);

	int nOldMode = pDC->SetBkMode(TRANSPARENT);
	//Title
	int nTitleWidth = int(rcClient.Width() * 0.6 + 0.5);

	CRect rcTitle(4, 0, nTitleWidth , STATUS_BAR_HEIGHT);
	pDC->MoveTo(rcTitle.right, rcTitle.top);
	pDC->LineTo(rcTitle.right, rcTitle.bottom);
	DrawTextEndEllipsis(pDC, 
		g_strCardFile.Mid(g_strCardFile.ReverseFind(_T('\\')) + 1), 
		rcTitle, DT_VCENTER | DT_SINGLELINE | DT_LEFT);
	//Card Info
	CString strCardInfo;
	if (g_ProgramMode == STUDY_MODE)
	{
		strCardInfo.Format(_T("%4d/%4d"), g_pCardSet->GetCardIndex() + 1, 
			g_pCardSet->GetNumCards());
	}
	else if (g_ProgramMode == MEMORIZE_MODE)
	{
		strCardInfo.Format(_T("%4d/%4d"), g_pCardSet->GetNumMemorizedCards(), 
			g_pCardSet->GetNumCards());
	}
	else //QUIZ_MODE
	{
		strCardInfo.Format(_T("%4d/%4d"), m_pQuizList->GetQuizIndex() + 1, 
			m_pQuizList->GetNumQuiz());
	}

	
	int nPercentWidth = int(rcClient.Width() * 0.854 + 0.5);
	rcTitle.SetRect(nTitleWidth + 1, 0, nPercentWidth, STATUS_BAR_HEIGHT);
	pDC->MoveTo(rcTitle.right, rcTitle.top);
	pDC->LineTo(rcTitle.right, rcTitle.bottom);
	pDC->DrawText(strCardInfo, rcTitle, DT_VCENTER | DT_SINGLELINE | DT_RIGHT);
	//Percent
	CString strPercent;
	UINT uiPercent;
	if (g_ProgramMode == STUDY_MODE)
	{
		uiPercent = UINT(g_pCardSet->GetCardIndex() / double(g_pCardSet->GetNumCards()) * 100.0 + 0.5);
		strPercent.Format(_T("%3d%%"), uiPercent);
	}
	else if (g_ProgramMode == MEMORIZE_MODE)
	{
		uiPercent = UINT(g_pCardSet->GetNumMemorizedCards() / double(g_pCardSet->GetNumCards()) * 100.0  + 0.5);	
		strPercent.Format(_T("%3d%%"), uiPercent);
	}
	else
	{
		uiPercent = UINT(m_pQuizList->GetNumHit() / double(m_pQuizList->GetNumQuiz()) * 100.0 + 0.5);
		strPercent.Format(_T("%3dP"), uiPercent);
	}

	rcTitle.SetRect(nPercentWidth, 0, rcClient.Width(), STATUS_BAR_HEIGHT);
	pDC->MoveTo(rcTitle.right, rcTitle.top);
	pDC->LineTo(rcTitle.right, rcTitle.bottom);
	pDC->DrawText(strPercent, rcTitle, DT_VCENTER | DT_SINGLELINE | DT_RIGHT);
	pDC->SetBkMode(nOldMode);
}

void CChildView::DrawCard(CDC* pDC, CCard* pCard, int& yStart)
{
	bool bShow;
	CFont* pOldFont;
	COLORREF crOldText;
	CRect rcClient, rcText, rcCalc;
	GetClientRect(&rcClient);
	int nOldMode = pDC->SetBkMode(TRANSPARENT);
	int yTop=0;		// 2007-02-02
	UINT uiAlignStyle=0;	// 2007-02-03

	bool bFirst = true;
	bool bDrawMark = false;

	if (m_bShowStatusIcon == TRUE)
	{
		if (g_ProgramMode ==  MEMORIZE_MODE) 
		{
			DrawQAMark(pDC, yStart, m_bQuestion);
			bDrawMark = true;
		}
		else if (g_ProgramMode ==  QUIZ_MODE)
		{
			DrawQAMark(pDC, yStart, TRUE);
			bDrawMark = true;
		}
		else //Study Mode
		{
			if (pCard->IsMemorized() == true)
			{
				DrawMMark(pDC, yStart);
				bDrawMark = true;
			}
		}
	}

	for (UINT i = 0; i < MAX_ITEM; i++)
	{
		if (g_ProgramMode ==  STUDY_MODE)
		{
			bShow = true;
		}
		else if (g_ProgramMode ==  MEMORIZE_MODE)
		{
			bShow = false;

			if (m_bQuestion == TRUE && g_pTemplate->IsShowInQuestion(i) == TRUE)
				bShow = true;
			if (m_bQuestion == FALSE && g_pTemplate->IsShowInAnswer(i) == TRUE)
				bShow = true;
		}
		else // Quiz Mode
		{
			if ( i == g_pQuizSetting->GetQuestionIndex() )
				bShow = true;
			else
				bShow = false;
		}

		// 2007-02-02 [ȯ] ⿡ DictionaryView Injection Ѵ.
		
		if (bShow == true)
		{
			if (pCard->GetWord(i) != NULL)
			{
				/* 2007-02-02 ȯ ߰  */
				if( m_bShowDictionaryView == TRUE)		// Dictionary View Mode
				{

					pOldFont = pDC->SelectObject(&m_fntItem[i]);
					crOldText = pDC->SetTextColor(m_rgbBack);			// ̰ɷ ڰ  δ.

					yStart +=  g_pTemplate->GetUpperMargin(i);
					TEXTMETRIC tm;
					ZeroMemory(&tm, sizeof(TEXTMETRIC));
					pDC->GetTextMetrics(&tm);
					rcText.SetRect(OUTER_MARGIN+2, 
						yStart, 
						rcClient.Width() - OUTER_MARGIN * 2 - 2, 
						yStart + tm.tmHeight);

					if (bFirst == true)
					{
						if ( bDrawMark == true)
							rcText.left += 16;
					}

					yTop = yStart;
					yStart += DrawCardText(pDC, pCard->GetWord(i), rcText, g_pTemplate->GetAlign(i));

					pDC->SetTextColor(crOldText);
					pDC->SelectObject(pOldFont);
					
					if( yStart == yTop )
						continue;

					// ⿡ ¥ rcText ũⰡ ȴ..
					rcText.SetRect(OUTER_MARGIN -1, 
						yTop, 
						rcClient.Width() - OUTER_MARGIN * 2 + 1, 
						yStart+g_pTemplate->GetUpperMargin(i));
					
					if (bFirst == true)
					{
						bFirst = false;
						if (bDrawMark == true)
							rcText.left += 16;
					}

					//  带 ش.
					switch( g_pTemplate->GetAlign(i) )
					{
						case DT_LEFT:
							uiAlignStyle = ES_LEFT;
							break;
						case DT_RIGHT:
							uiAlignStyle = ES_RIGHT;
							break;
						case DT_CENTER: default:
							uiAlignStyle = ES_CENTER;
							break;
					}

					// edit control ġѴ.
					m_pEditItem[i] = new CEdit();
					m_pEditItem[i]->Create(WS_CHILD | WS_VISIBLE | WS_TABSTOP | ES_AUTOVSCROLL | ES_MULTILINE | uiAlignStyle, rcText, this, ID_DICTIONARY_EDIT+i);
					m_pEditItem[i]->EnableWindow(TRUE);
					m_pEditItem[i]->SetFont( &m_fntItem[i], TRUE );
					m_pEditItem[i]->SetWindowText( pCard->GetWord(i) );

				}
				/* 2007-02-02 ȯ ߰  */
				else	// Normal View Mode
				{

					pOldFont = pDC->SelectObject(&m_fntItem[i]);
					crOldText = pDC->SetTextColor(g_pTemplate->GetFontColor(i));

					yStart +=  g_pTemplate->GetUpperMargin(i);
					TEXTMETRIC tm;
					ZeroMemory(&tm, sizeof(TEXTMETRIC));
					pDC->GetTextMetrics(&tm);
					rcText.SetRect(OUTER_MARGIN -1, yStart, 
						rcClient.Width() - OUTER_MARGIN * 2 + 1, 
						yStart + tm.tmHeight);

					if (bFirst == true)
					{
						bFirst = false;
						if (g_pTemplate->GetAlign(i) == DT_LEFT && bDrawMark == true)
							rcText.left += 16;
					}

					yStart += DrawCardText(pDC, pCard->GetWord(i), rcText, g_pTemplate->GetAlign(i));

					pDC->SetTextColor(crOldText);
					pDC->SelectObject(pOldFont);
				}
			}
		}
	}
	pDC->SetBkMode(nOldMode);
}


void CChildView::DrawExample(CDC* pDC, int yStart)
{
//	static int cnt = 0;
	CRect rcClient;
	GetClientRect(rcClient);
	CString str;

	//Draw the Header Line
	CPen blackPen(PS_SOLID, 1, RGB(0,0,255));
	CPen *pOldPen = pDC->SelectObject(&blackPen);
	pDC->MoveTo(0, yStart + 5);
	pDC->LineTo(rcClient.right, yStart + 5);
	pDC->SelectObject(pOldPen);	

	yStart += 10;
	int nInterval = (rcClient.Height() - yStart - 4) / g_pQuizSetting->GetNumExample();

	CRect rcButton;
	UINT i;

	for (i = 0; i < g_pQuizSetting->GetNumExample(); i++)
	{
		rcButton.left = 5;
		rcButton.top = yStart + nInterval * i;
		rcButton.right = rcButton.left + EXAM_BTN_WIDTH;
		rcButton.bottom = rcButton.top + (nInterval - 4);
		m_btnExam[i].MoveWindow(rcButton, TRUE);
	}

	// [ȯ] ⿡ ư ϱ.
	rcButton.left = rcClient.Width() - 50;
	rcButton.right = rcClient.Width() - 10;
	rcButton.top = rcClient.Height() - 30;
	rcButton.bottom = rcClient.Height() - 10;
	m_btnPass.MoveWindow(rcButton, TRUE);


	CQuiz* pQuiz = m_pQuizList->GetQuiz();
	CCard* pCard;

	CRect rcText;
	COLORREF crOldText;
	
	int nOldBkMode = pDC->SetBkMode(TRANSPARENT);
	CFont* pOldFont = pDC->SelectObject(&m_fntQuiz);
	LPCTSTR szExample;
	for (i = 0; i < g_pQuizSetting->GetNumExample(); i++)
	{
		if (m_bQuestion == TRUE)
			crOldText = pDC->SetTextColor(RGB(0, 0, 0));
		else
		{
			if (pQuiz->IsWrightAnswer(i))
				crOldText = pDC->SetTextColor(RGB(255, 0, 0));			// []  !
			else
				crOldText = pDC->SetTextColor(RGB(128, 128, 128));
		}

		TEXTMETRIC tm;
		ZeroMemory(&tm, sizeof(TEXTMETRIC));
		pDC->GetTextMetrics(&tm);
		rcText.SetRect(EXAM_BTN_WIDTH + OUTER_MARGIN * 2, 
			yStart, 
			rcClient.Width() - OUTER_MARGIN * 3, 
			yStart + tm.tmHeight);

		if (g_pQuizSetting->IsInternalExamMode() == TRUE)
		{
			szExample = pQuiz->GetExampleWord(i);	
		}
		else
		{
		//	[  ..]
//			// case 1.   ̸   
//			if( g_pQuizSetting->IsQuizResultSync() == TRUE ) {
//				//if( m_bQuestion == TRUE ) {
//					/*pCard = pQuiz->GetExampleCard(i);
//					szExample = pCard->GetWord(g_pQuizSetting->GetAnswerIndex());*/
//					// FIXME : ⼭  ߻...
//					// ư ⿡  ߻ϰ . GetParsedWord ȣ  ׾. ذ .
//					pCard = pQuiz->GetExampleCard(i);
//					szExample = CString(_T("")) + (char)(i+'0') + CString(_T(" ")) + (char)(pCard->GetParsedWordCount(i)+'0');
////					szExample = str = pCard->GetParsedWord(g_pQuizSetting->GetAnswerIndex(), pQuiz->GetExampleParsedWordIndex(i) );
//				/*}
//				else 		// case 2.   ̸    (ļ)
//				{
//					pCard = pQuiz->GetExampleCard(i);
//					szExample = pCard->GetParsedWord(g_pQuizSetting->GetAnswerIndex(), pQuiz->GetExampleParsedWordIndex(i) );
//				}*/
//
//			}
//			else			// case 3.   尡 ƴ 
//			{
			pCard = pQuiz->GetExampleCard(i);
			szExample = pCard->GetWord(g_pQuizSetting->GetAnswerIndex());
//			}
		}

		DrawCardText(pDC, szExample, rcText, DT_LEFT);
		/*************** [ȯ]  κ Ǿ.  **************/

		yStart += nInterval;
		pDC->SetTextColor(crOldText);
	}

/*		TEXTMETRIC tm;
		ZeroMemory(&tm, sizeof(TEXTMETRIC));
		pDC->GetTextMetrics(&tm);	rcText.SetRect(EXAM_BTN_WIDTH + OUTER_MARGIN * 2, 
			yStart, 
			rcClient.Width() - OUTER_MARGIN * 3, 
			yStart + tm.tmHeight);
	pDC->DrawText(_T("Simple message box."), -1, rcText, DT_NOPREFIX | DT_LEFT | DT_WORDBREAK | DT_CALCRECT);
*/
	pDC->SetBkMode(nOldBkMode);
	pDC->SelectObject(pOldFont);		
}

int CChildView::DrawCardText(CDC* pDC, LPCTSTR szWord, RECT* prcText, UINT uiAlign)
{
	CString strDraw(szWord);
	ConvertNewLine(strDraw);

	int nTextHeight;
	if (m_bWordWrap == TRUE)
	{
		CRect rcCalc = *prcText;
		int nHeight = pDC->DrawText(strDraw, -1, rcCalc, 
			DT_NOPREFIX | uiAlign | DT_WORDBREAK | DT_CALCRECT);

		if (nHeight > (prcText->bottom - prcText->top)) // 1 Ѵ  
		{
			prcText->bottom = rcCalc.bottom;
			nTextHeight = pDC->DrawText(strDraw, -1, prcText, 
				DT_NOPREFIX | uiAlign | DT_WORDBREAK);
		}
		else
		{
			nTextHeight = pDC->DrawText(strDraw, -1, prcText, 
				DEFAULT_FORMAT | uiAlign);
		}
	}
	else
	{
		nTextHeight = DrawMultiLineString(pDC, strDraw, 
			prcText, DEFAULT_FORMAT | uiAlign);
	}
	return nTextHeight;
}


void CChildView::DrawQuizResult(CDC* pDC, int yStart)
{
	CQuiz* pQuiz = m_pQuizList->GetQuiz();
	CRect rcClient;
	GetClientRect(rcClient);
	rcClient.top += yStart;

	CBitmap* pbmpDraw;
	if (pQuiz->IsCorret())
		pbmpDraw = &m_bmpOMark;
	else
		pbmpDraw = &m_bmpXMark;

	BITMAP bmp;
	pbmpDraw->GetBitmap(&bmp);

	int x = (rcClient.Width() - bmp.bmWidth) / 2 ;
	int y = (rcClient.Height() - bmp.bmHeight) / 2 + rcClient.top;

	HBITMAP hbmpDraw = (HBITMAP)(*pbmpDraw);
	TransparentImage(pDC->m_hDC,
		x, 
		y, 
		bmp.bmWidth, 
		bmp.bmHeight,
		hbmpDraw,
		0, 
		0, 
		bmp.bmWidth, 
		bmp.bmHeight,
		RGB(255, 255, 255)
	);
}

void CChildView::DrawQAMark(CDC* pDC, int yStart, BOOL bQuestion)
{
	CBitmap* pbmpDraw;
	if (bQuestion == TRUE)
		pbmpDraw = &m_bmpQMark;
	else
		pbmpDraw = &m_bmpAMark;

	BITMAP bmp;
	pbmpDraw->GetBitmap(&bmp);

	int x = 0;
	int y = yStart;

	HBITMAP hbmpDraw = (HBITMAP)(*pbmpDraw);
	TransparentImage(pDC->m_hDC,
		x, 
		y, 
		bmp.bmWidth, 
		bmp.bmHeight,
		hbmpDraw,
		0, 
		0, 
		bmp.bmWidth, 
		bmp.bmHeight,
		RGB(255, 255, 0)
	);
}

void CChildView::DrawMMark(CDC* pDC, int yStart)
{
	BITMAP bmp;
	m_bmpMMark.GetBitmap(&bmp);

	int x = 0;
	int y = yStart;

	HBITMAP hbmpDraw = (HBITMAP)(m_bmpMMark);
	TransparentImage(pDC->m_hDC,
		x, 
		y, 
		bmp.bmWidth, 
		bmp.bmHeight,
		hbmpDraw,
		0, 
		0, 
		bmp.bmWidth, 
		bmp.bmHeight,
		RGB(255, 255, 0)
	);
}


int CChildView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CWnd ::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	BuildFonts();

	LOGFONT lf;
	memset(&lf, 0, sizeof(LOGFONT));
	lstrcpy(lf.lfFaceName, DEFAULT_FONT); 
	lf.lfHeight = 26;
	lf.lfItalic = false;
	lf.lfWeight = FW_BOLD;
	m_fntTimerLimit.CreateFontIndirect(&lf);

	m_bmpOMark.LoadBitmap(IDB_O_MARK);
	m_bmpXMark.LoadBitmap(IDB_X_MARK);
	m_bmpQMark.LoadBitmap(IDB_Q_MARK);
	m_bmpAMark.LoadBitmap(IDB_A_MARK);
	m_bmpMMark.LoadBitmap(IDB_M_MARK);

	m_pStrokeView->OnCreate(this);

	CreateButtons();

	ChangeMode(STUDY_MODE, true);

	return 0;
}

BOOL CChildView::CreateButtons()
{
	CString strBtnName;
	CRect rcButton(0, 0, 0, 0);
	strBtnName.LoadString(IDS_SHOW_ANSWER);
	m_btnShow.Create(strBtnName, 
		WS_VISIBLE | WS_CHILD | BS_PUSHBUTTON | BS_CENTER | BS_VCENTER , 
		rcButton, this, ID_SHOW_ANSWER);

	strBtnName.LoadString(IDS_SHOW_CORRECT);
	m_btnRight.Create(strBtnName, 
		WS_VISIBLE | WS_CHILD | BS_PUSHBUTTON | BS_CENTER | BS_VCENTER , 
		rcButton, this, ID_SHOW_RIGHT);

	strBtnName.LoadString(IDS_SHOW_WRONG);
	m_btnWrong.Create(strBtnName, 
		WS_VISIBLE | WS_CHILD | BS_PUSHBUTTON | BS_CENTER | BS_VCENTER , 
		rcButton, this, ID_SHOW_WRONG);

	strBtnName.LoadString(IDS_SHOW_PREVIOUS);
	m_btnPrev.Create(strBtnName, 
		WS_VISIBLE | WS_CHILD | BS_PUSHBUTTON | BS_CENTER | BS_VCENTER , 
		rcButton, this, ID_SHOW_PREV);

	strBtnName.LoadString(IDS_SHOW_NEXT);
	m_btnNext.Create(strBtnName, 
		WS_VISIBLE | WS_CHILD | BS_PUSHBUTTON | BS_CENTER | BS_VCENTER , 
		rcButton, this, ID_SHOW_NEXT);

	strBtnName.LoadString(IDS_STOP_AUTO);
	m_btnStop.Create(strBtnName,
		WS_VISIBLE | WS_CHILD | BS_PUSHBUTTON | BS_CENTER | BS_VCENTER , 
		rcButton, this, ID_STOP_AUTO);

	CString strText;
	for (int i = 0; i < NUM_MAX_EXAMPLE; i++)
	{
		strText.Format(_T("%d"), i + 1);
		m_btnExam[i].Create(strText, 
				WS_VISIBLE | WS_CHILD | BS_PUSHBUTTON | BS_CENTER | BS_VCENTER , 
				rcButton, this, ID_ANSWER_1 + i);
	}
	m_btnPass.Create(_T("Pass"), 
			WS_VISIBLE | WS_CHILD | BS_PUSHBUTTON | BS_CENTER | BS_VCENTER , 
			rcButton, this, ID_ANSWER_PASS);

	return TRUE;
}

void CChildView::UpdateButtonState()
{
	if (m_pCurrentCard == NULL)
	{
		m_btnShow.ShowWindow(SW_HIDE);
		m_btnRight.ShowWindow(SW_HIDE);
		m_btnWrong.ShowWindow(SW_HIDE);
		m_btnPrev.ShowWindow(SW_HIDE);
		m_btnNext.ShowWindow(SW_HIDE);
		m_btnStop.ShowWindow(SW_HIDE);
		for (int i = 0; i < NUM_MAX_EXAMPLE; i++)
			m_btnExam[i].ShowWindow(SW_HIDE);
		m_btnPass.ShowWindow(SW_HIDE);
	}
	else
	{
		if (g_ProgramMode == STUDY_MODE )
		{
			if (m_bAutoProgress == TRUE)
			{
				m_btnShow.ShowWindow(SW_HIDE);
				m_btnRight.ShowWindow(SW_HIDE);
				m_btnWrong.ShowWindow(SW_HIDE);
				m_btnPrev.ShowWindow(SW_HIDE);
				m_btnNext.ShowWindow(SW_HIDE);
				for (int i = 0; i < NUM_MAX_EXAMPLE; i++)
					m_btnExam[i].ShowWindow(SW_HIDE);
				m_btnPass.ShowWindow(SW_HIDE);
				m_btnStop.ShowWindow(SW_SHOW);
			}
			else
			{
				m_btnShow.ShowWindow(SW_HIDE);
				m_btnRight.ShowWindow(SW_HIDE);
				m_btnWrong.ShowWindow(SW_HIDE);
				m_btnPrev.ShowWindow(SW_SHOW);
				m_btnNext.ShowWindow(SW_SHOW);
				for (int i = 0; i < NUM_MAX_EXAMPLE; i++)
					m_btnExam[i].ShowWindow(SW_HIDE);
				m_btnPass.ShowWindow(SW_HIDE);
				m_btnStop.ShowWindow(SW_HIDE);
			}
		}
		else if (g_ProgramMode == MEMORIZE_MODE)
		{
			if (m_bAutoProgress == TRUE)
			{
				m_btnShow.ShowWindow(SW_HIDE);
				m_btnRight.ShowWindow(SW_HIDE);
				m_btnWrong.ShowWindow(SW_HIDE);
				m_btnPrev.ShowWindow(SW_HIDE);
				m_btnNext.ShowWindow(SW_HIDE);
				for (int i = 0; i < NUM_MAX_EXAMPLE; i++)
					m_btnExam[i].ShowWindow(SW_HIDE);
				m_btnPass.ShowWindow(SW_HIDE);
				m_btnStop.ShowWindow(SW_SHOW);
			}
			else
			{
				if (m_bQuestion == TRUE)
				{
					m_btnShow.ShowWindow(SW_SHOW);
					m_btnRight.ShowWindow(SW_HIDE);
					m_btnWrong.ShowWindow(SW_HIDE);
				}
				else
				{
					m_btnShow.ShowWindow(SW_HIDE);
					m_btnRight.ShowWindow(SW_SHOW);
					m_btnWrong.ShowWindow(SW_SHOW);
				}
				m_btnPrev.ShowWindow(SW_HIDE);
				m_btnNext.ShowWindow(SW_HIDE);
				for (int i = 0; i < NUM_MAX_EXAMPLE; i++)
					m_btnExam[i].ShowWindow(SW_HIDE);
				m_btnPass.ShowWindow(SW_HIDE);
				m_btnStop.ShowWindow(SW_HIDE);
			}
		}
		else  //QUIZ_MODE
		{
			if (m_bQuestion == TRUE)
			{
				for (UINT i = 0; i < NUM_MAX_EXAMPLE; i++)
				{
					if (i < g_pQuizSetting->GetNumExample())
					{
						m_btnExam[i].ShowWindow(SW_SHOW);
						m_btnExam[i].EnableWindow(TRUE);
					}
					else
						m_btnExam[i].ShowWindow(SW_HIDE);
				}
				m_btnPass.ShowWindow(SW_SHOW);
				m_btnPass.EnableWindow(TRUE);
			}
			else
			{
				for (UINT i = 0; i < NUM_MAX_EXAMPLE; i++)
				{
					if (i < g_pQuizSetting->GetNumExample())
					{
						m_btnExam[i].ShowWindow(SW_SHOW);
						m_btnExam[i].EnableWindow(FALSE);
					}
					else
						m_btnExam[i].ShowWindow(SW_HIDE);
				}
				m_btnPass.ShowWindow(SW_SHOW);
				m_btnPass.EnableWindow(FALSE);
			}

			m_btnShow.ShowWindow(SW_HIDE);
			m_btnRight.ShowWindow(SW_HIDE);
			m_btnWrong.ShowWindow(SW_HIDE);
			m_btnPrev.ShowWindow(SW_HIDE);
			m_btnNext.ShowWindow(SW_HIDE);
			m_btnStop.ShowWindow(SW_HIDE);
		}
	}
}

BOOL CChildView::BuildFonts()
{
	LOGFONT lf;
	LPCTSTR szFontName;
	for (int i = 0; i < MAX_ITEM; i ++)
	{
		if (m_fntItem[i].m_hObject != NULL)
			m_fntItem[i].DeleteObject();

		memset(&lf, 0, sizeof(LOGFONT));
		//lstrcpy(lf.lfFaceName, DEFAULT_FONT); 
		szFontName = g_pTemplate->GetFontName(i);
		if (szFontName == NULL || lstrlen(szFontName) == 0)
			szFontName = DEFAULT_FONT;
		lstrcpy(lf.lfFaceName, szFontName); 
		BYTE byCharSet = g_pTemplate->GetFontCharSet(i);
		if ( byCharSet != 0)
			lf.lfCharSet = byCharSet;
		lf.lfHeight = g_pTemplate->GetFontSize(i) * 10;
		lf.lfItalic = g_pTemplate->IsItalicFont(i);
		if (g_pTemplate->IsClearTypeFont(i))
			lf.lfQuality = CLEARTYPE_QUALITY;
		else
			lf.lfQuality = DEFAULT_QUALITY;

		if (g_pTemplate->IsBoldFont(i))
			lf.lfWeight = FW_BOLD;
		BOOL bRet = m_fntItem[i].CreatePointFontIndirect(&lf);
	}

	BuildQuizFont();

	return TRUE;
}

BOOL CChildView::BuildQuizFont()
{
	if (m_fntQuiz.m_hObject != NULL)
		m_fntQuiz.DeleteObject();

	int nIndex = g_pQuizSetting->GetAnswerIndex();

	LOGFONT lf;

	memset(&lf, 0, sizeof(LOGFONT));

	LPCTSTR szFontName = g_pTemplate->GetFontName(nIndex);
	if (szFontName == NULL || lstrlen(szFontName) == 0)
		szFontName = DEFAULT_FONT;

	lstrcpy(lf.lfFaceName, szFontName); 
	BYTE byCharSet = g_pTemplate->GetFontCharSet(nIndex);
	if ( byCharSet != 0)
		lf.lfCharSet = byCharSet;
	lf.lfHeight = g_pQuizSetting->GetFontSize() * 10;
	lf.lfWeight = 0;
	lf.lfItalic = false;
	lf.lfQuality = DEFAULT_QUALITY;
	lf.lfWeight = 0;

	return m_fntQuiz.CreatePointFontIndirect(&lf);
}


void CChildView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	if (m_pCurrentCard == NULL)
		return;
	if (g_ProgramMode == QUIZ_MODE)
	{
		if (m_bQuestion == FALSE)
			MoveToNextQuiz();
	}
	else
	{
		m_pStrokeView->OnLButtonDown(nFlags, point);
		//ġ  ̵ ̾α ó 
		CRect rcClient;
		GetClientRect(rcClient);
		int nTitleWidth = int(rcClient.Width() * 0.6 + 0.5);
		CRect rcArea(nTitleWidth + 1, 0,  rcClient.Width(), STATUS_BAR_HEIGHT);
		if (rcArea.PtInRect(point) == TRUE)
			OnMoveCard();
	}
	//CWnd ::OnLButtonDown(nFlags, point);
}

void CChildView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	m_pStrokeView->OnLButtonUp(nFlags, point);
	//CWnd ::OnLButtonUp(nFlags, point);
}

void CChildView::OnMouseMove(UINT nFlags, CPoint point) 
{
	m_pStrokeView->OnMouseMove(nFlags, point);
	
	//CWnd ::OnMouseMove(nFlags, point);
}



BOOL CChildView::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	switch(LOWORD(wParam))
	{
		case ID_SHOW_ANSWER: //亸
			ShowAnswerCard();
			break;
		case ID_SHOW_RIGHT:
			AnswerOnCard(true);
			break;
		case ID_SHOW_WRONG:
			AnswerOnCard(false);
			break;
		case ID_SHOW_PREV:
			MoveToPrevCard();
			break;
		case ID_SHOW_NEXT:
			MoveToNextCard();
			break;
		case ID_ANSWER_1:
			AnswerOnQuiz(0);
			break;
		case ID_ANSWER_2:
			AnswerOnQuiz(1);
			break;
		case ID_ANSWER_3:
			AnswerOnQuiz(2);
			break;
		case ID_ANSWER_4:
			AnswerOnQuiz(3);
			break;
		case ID_ANSWER_5:
			AnswerOnQuiz(4);
			break;
		case ID_ANSWER_6:
			AnswerOnQuiz(5);
			break;
		case ID_ANSWER_PASS:
			AnswerOnQuiz(-1);
			break;
		case ID_STOP_AUTO:
			KillTimer(ID_TIMER_AUTO_PROGRESS);
			m_bAutoProgress = FALSE;
			UpdateButtonState();
			InvalidateRect(NULL);
			break;
	}
	m_pStrokeView->OnCommand(wParam, lParam);
	
	return CWnd ::OnCommand(wParam, lParam);
}

// ̰ "ϱ" üũ̴.
void CChildView::AnswerOnCard(BOOL bRight)
{
	if (m_bQuestion == FALSE)
	{
		if (bRight == TRUE)
		{
			m_pCurrentCard->Memorized();
			g_pCardSet->IncreaseMemorizedCardCount();
		}

		m_bQuestion = TRUE;
		UpdateButtonState();

		//  Ȯ 
		if (g_pCardSet->GetNumCards() == g_pCardSet->GetNumMemorizedCards())
		{
			InvalidateRect(NULL);
			g_pCardSet->ResetMemorizing();
			CString strMsg;
			strMsg.LoadString(IDS_ALL_MEMORIZED);
			if (MessageBox(strMsg, AfxGetAppName(), MB_YESNO | MB_ICONQUESTION) == IDYES)
				ChangeMode(MEMORIZE_MODE, true);
			else
				ChangeMode(STUDY_MODE);
		}
		else
		{
			if (m_bSeqMemoMode == TRUE)
				m_pCurrentCard = g_pCardSet->GetCardFromList(false);
			else
				m_pCurrentCard = g_pCardSet->GetCardFromRandomList(false);

			if (m_uiTimerLimit > 0)
			{
				SetTimer(ID_TIMER_LIMIT, 1000, NULL);
				m_uiTimerCount = m_uiTimerLimit;
			}

			m_pStrokeView->Clear();
			InvalidateRect(NULL);
		}
	}
}

void CChildView::AnswerOnQuiz(int nAnswer)
{
//	CString strMsg;

	if (m_bQuestion == TRUE)
	{
		bool bRight = m_pQuizList->AnswerOnQuiz(nAnswer);
		CCard *pCard;

		/* [ȯ] Sync 尡 üũǾ     ī ϱ ¿ ݿȴ */
		// m_pCurrentCard ġϴ   óϿ Ѵ.
		if( g_pQuizSetting->IsQuizResultSync() ) {

			if( bRight ) {	//  
				pCard = m_pQuizList->GetQuiz()->GetQuizCard();
				if( pCard->IsNotMemorized() ) {	//  ܿµ    state .
					pCard->Memorized();
					g_pCardSet->IncreaseMemorizedCardCount();
					//      Ƿ, Ʒ  ߰ óѴ.
					if( pCard == m_pCurrentCard ) {
						//    Ѵ.
						if (g_pCardSet->GetNumCards() != g_pCardSet->GetNumMemorizedCards()) {
							if (m_bSeqMemoMode == TRUE)
								m_pCurrentCard = g_pCardSet->GetCardFromList(false);
							else
								m_pCurrentCard = g_pCardSet->GetCardFromRandomList(false);
						}
					}
//					strMsg = "ChangedToMemorized!";
//					MessageBox(strMsg, AfxGetAppName(), MB_OK | MB_ICONWARNING);
				}
			} else {	//  
				pCard = m_pQuizList->GetQuiz()->GetQuizCard();
				if( pCard->IsMemorized() ) {	// ܿµ Ʋ  state .
					pCard->Reset();
					g_pCardSet->DecreaseMemorizedCardCount();
//					strMsg = "ChangedToNotMemorized!";
//					MessageBox(strMsg, AfxGetAppName(), MB_OK | MB_ICONWARNING);
				}
			}
		}
		
		KillTimer(ID_TIMER_LIMIT);
		m_bQuestion = FALSE;
		UpdateButtonState();
		InvalidateRect(NULL);

		//  Ǭ  
		if (m_pQuizList->GetQuizIndex() + 1 == m_pQuizList->GetNumQuiz())
		{
			CString strMsg;
			UINT uiPoint = UINT(m_pQuizList->GetNumHit() / double(m_pQuizList->GetNumQuiz()) * 100.0 + 0.5);
			CString strTemp;
			strTemp.LoadString(IDS_COMPLETE_QUIZ);
			strMsg.Format(strTemp, uiPoint);
			if (MessageBox(strMsg, AfxGetAppName(), MB_YESNO | MB_ICONQUESTION) == IDYES)
			{
				ChangeMode(QUIZ_MODE, true);
			}
			else
			{
				ChangeMode(STUDY_MODE);
			}
		}
	}
}


void CChildView::ShowAnswerCard()
{
	if (m_bQuestion == TRUE)
	{
		KillTimer(ID_TIMER_LIMIT);
		m_bQuestion = FALSE;
		UpdateButtonState();
		InvalidateRect(NULL);
	}
}

void CChildView::MoveToNextQuiz()
{
	m_pQuizList->MoveToNext();
	m_bQuestion = TRUE;
	if (m_uiTimerLimit > 0)
	{
		SetTimer(ID_TIMER_LIMIT, 1000, NULL);
		m_uiTimerCount = m_uiTimerLimit;
	}
	UpdateButtonState();
	InvalidateRect(NULL);
}

void CChildView::MoveToNextCard()
{
	if (g_pCardSet->IsLastCard() == true)
		g_pCardSet->MoveToFirst();
	else
		g_pCardSet->MoveNext();
	m_pCurrentCard = g_pCardSet->GetCard();
	m_pStrokeView->Clear();
	InvalidateRect(NULL);
}

void CChildView::MoveToPrevCard()
{
	if (g_pCardSet->IsFirstCard() != true)
		g_pCardSet->MovePrev();
	else
		g_pCardSet->MoveToLast();
	m_pCurrentCard = g_pCardSet->GetCard();
	m_pStrokeView->Clear();
	InvalidateRect(NULL);
}

void CChildView::ChangeMode(PROGRAM_MODE NewMode, bool bInit)
{
	if (g_ProgramMode != NewMode || bInit == true)
	{
		if (NewMode == QUIZ_MODE )
		{
			if (g_pQuizSetting->CheckSetting(g_pCardSet) == FALSE)
			{
				CString strMsg;
				strMsg.LoadString(IDS_INVALID_QUIZ_RANGE);
				MessageBox(strMsg, AfxGetAppName(), MB_OK | MB_ICONWARNING);
				return;
			}
		}

		g_ProgramMode = NewMode;
		m_pStrokeView->Clear();

		if (g_ProgramMode == STUDY_MODE)
		{
			m_pStrokeView->ShowView(m_bShowStrokeView);
			m_pCurrentCard = g_pCardSet->GetCard();
			//if (bInit == true)
			//	g_pCardSet->MoveToFirst(false);
		}
		else if (g_ProgramMode == MEMORIZE_MODE)
		{
			m_bQuestion = TRUE;
			m_pStrokeView->ShowView(m_bShowStrokeView);

			if (m_bSeqMemoMode == TRUE)
				m_pCurrentCard = g_pCardSet->GetCardFromList(false);
			else
				m_pCurrentCard = g_pCardSet->GetCardFromRandomList(false);
		}
		else // QUIZ_MODE
		{
			m_bQuestion = TRUE;
			m_pStrokeView->ShowView(FALSE);
			m_pCurrentCard = g_pCardSet->GetCard();
			m_pQuizList->GenerateList(g_pCardSet, g_pQuizSetting);
		}

		KillTimer(ID_TIMER_LIMIT);
		if (m_uiTimerLimit > 0)
		{
			SetTimer(ID_TIMER_LIMIT, 1000, NULL);
			m_uiTimerCount = m_uiTimerLimit;
		}

		if (m_bAutoProgress == TRUE)
		{
			KillTimer(ID_TIMER_AUTO_PROGRESS);
			m_bAutoProgress = FALSE;
		}

		UpdateButtonState();
		InvalidateRect(NULL);
	}
}

/*
BOOL CChildView::CheckQuizSetting() 
{
	UINT uiSelectCard;
	//ϱ ī常  ϴ  
	if (g_pQuizSetting->IsMemorizedCardOnly() == TRUE)
	{
		uiSelectCard = g_pCardSet->GetNumMemorizedCards();
		if (uiSelectCard < g_pQuizSetting->GetTotalQuiz())
		{
			//ϱ ī      
			CString strMsg;
			strMsg.LoadString(IDS_TOO_FEW_MEMORIZED_CARDS);
			MessageBox(strMsg, AfxGetAppName(), MB_OK | MB_ICONWARNING);
			return FALSE;
		}
	}
	else if (g_pQuizSetting->IsSelectedCardOnly() == TRUE)
	{
		// ī 
		uiSelectCard = g_pQuizSetting->GetEndCardIndex() - g_pQuizSetting->GetStartCardIndex() + 1;
		if (uiSelectCard < g_pQuizSetting->GetTotalQuiz())
		{
			CString strMsg;
			strMsg.LoadString(IDS_TOO_SMALL_QUIZ_RANGE);
			MessageBox(strMsg, AfxGetAppName(), MB_OK | MB_ICONWARNING);
			return FALSE;
		}
	}
	else 
	{
		//ü ī
		uiSelectCard = g_pQuizSetting->GetTotalQuiz();
		if ( uiSelectCard > g_pCardSet->GetNumCards())
		{
			CString strMsg;
			strMsg.LoadString(IDS_TOO_MANY_QUIZ_NUMBER);
			MessageBox(strMsg, AfxGetAppName(), MB_OK | MB_ICONWARNING);
			return FALSE;
		}
	}

	//ī  ˻
	if (uiSelectCard < g_pQuizSetting->GetNumExample() )
	{
		CString strMsg;
		strMsg.LoadString(IDS_TOO_FEW_CARD);
		MessageBox(strMsg, AfxGetAppName(), MB_OK | MB_ICONSTOP);
		return FALSE;
	}

	return TRUE;
}
*/

void CChildView::OnTimer5sec() 
{
	ChangeTimer(5);	
}

void CChildView::OnTimer10sec() 
{
	ChangeTimer(10);
}

void CChildView::OnTimer20sec() 
{
	ChangeTimer(20);
}

void CChildView::OnTimer30sec() 
{
	ChangeTimer(30);
}

void CChildView::OnTimer60sec() 
{
	ChangeTimer(60);	
}

void CChildView::OnTimerUnlimit() 
{
	ChangeTimer(0);
}

void CChildView::ChangeTimer(UINT uiTimer)
{
	if (m_uiTimerLimit != uiTimer)
		m_uiTimerLimit = uiTimer;
}

void CChildView::OnDestroy() 
{
	KillTimer(ID_TIMER_LIMIT);	
	KillTimer(ID_TIMER_AUTO_PROGRESS);
	//Save file
	CWnd ::OnDestroy();
}

void CChildView::OnTimer(UINT nIDEvent) 
{
	if (nIDEvent == ID_TIMER_LIMIT)
	{
		m_uiTimerCount--;
		if (m_uiTimerCount == 0) //ð ٵ  
		{
			if (g_ProgramMode == MEMORIZE_MODE)
				ShowAnswerCard();
			else
				AnswerOnQuiz(-1);
		}
		else
		{
			CRect rcClient;
			GetClientRect(&rcClient);
			CRect rcCounter;
			rcCounter.left = rcClient.Width() - 4 - TIMER_WIDTH;
			//rcCounter.top = TIMER_Y_POS;
			rcCounter.top = rcClient.Height() - TIMER_HEIGHT;
			rcCounter.right = rcCounter.left + TIMER_WIDTH;
			rcCounter.bottom = rcCounter.top + TIMER_HEIGHT;			
			InvalidateRect(rcCounter, TRUE);
		}
	}
	else if (nIDEvent == ID_TIMER_AUTO_PROGRESS)
	{
		if (g_ProgramMode == STUDY_MODE)
		{
			if (g_pCardSet->IsLastCard() == true && m_bAutoRepeat == FALSE) // ī  
			{
				KillTimer(ID_TIMER_AUTO_PROGRESS);
				m_bAutoProgress = FALSE;
				UpdateButtonState();
			}
			else
				MoveToNextCard();
		}
		else //Memorize Mode
		{
			if (m_bQuestion == TRUE)
				ShowAnswerCard();
			else
				AnswerOnCard(FALSE);
		}
	}
	CWnd ::OnTimer(nIDEvent);
}

void CChildView::OnEditCard() 
{
	if (m_pCurrentCard != NULL)
	{
		CEditCardDlg dlgEditCard(m_pCurrentCard, g_pTemplate);
		if (dlgEditCard.DoModal() == IDOK)
		{
			bool bModified = false;
			bModified |= m_pCurrentCard->SetWord(0, dlgEditCard.m_strValue1);
			bModified |= m_pCurrentCard->SetWord(1, dlgEditCard.m_strValue2);
			bModified |= m_pCurrentCard->SetWord(2, dlgEditCard.m_strValue3);
			bModified |= m_pCurrentCard->SetWord(3, dlgEditCard.m_strValue4);
			bModified |= m_pCurrentCard->SetWord(4, dlgEditCard.m_strValue5);
			bModified |= m_pCurrentCard->SetWord(5, dlgEditCard.m_strValue6);

			if (bModified == true)
			{
				g_pCardSet->ModifiedCard();
				InvalidateRect(NULL);
			}
		}
	}
}

void CChildView::OnItemAttr() 
{
	CTemplateSetupDlg dlgItemAttr(g_pTemplate);
	if (dlgItemAttr.DoModal() == IDOK)
	{
		if (g_pTemplate != dlgItemAttr.GetTemplate()) //ø ü   (Import)
			g_pTemplate = dlgItemAttr.GetTemplate();

		if (dlgItemAttr.IsNeedFontRebuild() == true)
			BuildFonts();

		InvalidateRect(NULL, TRUE);
	}
}

void CChildView::OnStrokeView() 
{
	m_bShowStrokeView =!m_bShowStrokeView;
	m_pStrokeView->ShowView(m_bShowStrokeView);
}

void CChildView::OnDictionaryView()		// 2007-02-02 ߰
{
	m_bShowDictionaryView =!m_bShowDictionaryView;
}

void CChildView::OnDelCard() 
{
	if (g_pCardSet->GetNumCards() > 0)
	{
		CString strMsg;
		strMsg.LoadString(IDS_DELETE_CARD);
		if (MessageBox(strMsg, AfxGetAppName(), MB_YESNO | MB_ICONQUESTION) == IDYES)
		{
			g_pCardSet->DeleteCurrentCard();
			m_pStrokeView->Clear();
			m_pCurrentCard = g_pCardSet->GetCard();
			InvalidateRect(NULL);
		}
	}
}

void CChildView::OnAddCard() 
{
	CCard* pCard = new CCard();

	CEditCardDlg dlgEditCard(pCard, g_pTemplate);
	if (dlgEditCard.DoModal() == IDOK)
	{
		pCard->SetWord(0, dlgEditCard.m_strValue1);
		pCard->SetWord(1, dlgEditCard.m_strValue2);
		pCard->SetWord(2, dlgEditCard.m_strValue3);
		pCard->SetWord(3, dlgEditCard.m_strValue4);
		pCard->SetWord(4, dlgEditCard.m_strValue5);
		pCard->SetWord(5, dlgEditCard.m_strValue6);
		
		g_pCardSet->InsertCard(pCard);
		m_pStrokeView->Clear();
		m_pCurrentCard = g_pCardSet->GetCard();
		InvalidateRect(NULL);
	}
	else
	{
		delete pCard;
	}
}

void CChildView::OnMoveCard() 
{
	CGotoCardDlg dlgGotoCard(g_pCardSet, this);
	if (IDOK == dlgGotoCard.DoModal())
	{
		m_pCurrentCard = g_pCardSet->GetCard();
		m_pStrokeView->Clear();
		InvalidateRect(NULL);		
	}
}

void CChildView::OnAddBookmark() 
{
	g_pCardSet->SetBookmark();	
}

void CChildView::OnSize(UINT nType, int cx, int cy) 
{
	CWnd ::OnSize(nType, cx, cy);

	CRect rcWnd;
	rcWnd.left = 4;
	rcWnd.bottom = cy - 4;
	int nButtonWidth = (cx - 4 - 4 - 4) / 2;
	rcWnd.right = rcWnd.left + nButtonWidth;
	rcWnd.top = rcWnd.bottom - m_dwButtonSize;

	m_btnRight.MoveWindow(rcWnd, TRUE);
	m_btnPrev.MoveWindow(rcWnd, TRUE);

	rcWnd.left = rcWnd.right + 4;
	rcWnd.right = rcWnd.left + nButtonWidth;
	m_btnShow.MoveWindow(rcWnd, TRUE);
	m_btnWrong.MoveWindow(rcWnd, TRUE);
	m_btnNext.MoveWindow(rcWnd, TRUE);
	m_btnStop.MoveWindow(rcWnd, TRUE);

	m_pStrokeView->OnSize(nType, cx, cy, m_dwButtonSize);
}


void CChildView::OnSetupQuiz() 
{
	CQuizSetupDlg dlgQuizSetup(g_pQuizSetting, g_pTemplate,
		g_pCardSet->GetNumCards(), this);

	if (IDOK == dlgQuizSetup.DoModal())
	{
		if (dlgQuizSetup.IsNeedFontRebuild())
			BuildQuizFont();
	}
}

void CChildView::OnAutoProgress() 
{
	if (m_bAutoProgress == TRUE)
		return;
	CDlgAutoProgress dlgAutoProgress(g_ProgramMode == STUDY_MODE, this);

	if (IDOK == dlgAutoProgress.DoModal())
	{
		if (g_ProgramMode == STUDY_MODE && 
			dlgAutoProgress.m_bStartFromFirst)
		{
			g_pCardSet->MoveToFirst();
			m_pCurrentCard = g_pCardSet->GetCard();
		}

		m_bAutoRepeat = dlgAutoProgress.m_bRepeat;
		m_bAutoProgress = TRUE;
		SetTimer(ID_TIMER_AUTO_PROGRESS, dlgAutoProgress.m_dwTimeInterval * 1000, NULL);
		m_pStrokeView->Clear();
		UpdateButtonState();
		InvalidateRect(NULL);
	}
}


void CChildView::OnOptions() 
{
	COptionDlg dlgOption;
	dlgOption.m_rgbBack = m_rgbBack;
	dlgOption.m_rgbPen = m_pStrokeView->GetPenColor();
	dlgOption.m_bWordwrap = m_bWordWrap;
	dlgOption.m_bSeqMemoMode = m_bSeqMemoMode;
	dlgOption.m_dwButtonSize = m_dwButtonSize;
	dlgOption.m_bShowStatusIcon = m_bShowStatusIcon;
	dlgOption.m_nPenWidth = m_pStrokeView->GetPenWidth();
	if (IDOK == dlgOption.DoModal())
	{
		m_rgbBack = dlgOption.m_rgbBack;
		m_pStrokeView->SetPenColor(dlgOption.m_rgbPen);
		m_pStrokeView->SetPenWidth(dlgOption.m_nPenWidth);
		m_bWordWrap = dlgOption.m_bWordwrap;
		m_bSeqMemoMode = dlgOption.m_bSeqMemoMode;
		m_bShowStatusIcon = dlgOption.m_bShowStatusIcon;
		if (dlgOption.m_dwButtonSize != m_dwButtonSize)
		{
			m_dwButtonSize = dlgOption.m_dwButtonSize;
			CRect rcClient;
			GetClientRect(rcClient);
			SendMessage(WM_SIZE, (WPARAM)SIZE_RESTORED, 
				MAKELPARAM(rcClient.Width(), rcClient.Height() ) );
		}
		InvalidateRect(NULL, TRUE);
	}
}

void CChildView::OnEditFind() 
{
	CFindDlg dlgFind(g_pTemplate);
	if (m_strPrevFind.GetLength() > 0)
		dlgFind.m_strFind = m_strPrevFind;
	if (IDOK == dlgFind.DoModal())
	{
		POSITION posFind;
		if (dlgFind.m_bSelectItemOnly == TRUE)
		{
			posFind = g_pCardSet->FindCard(dlgFind.m_strFind, TRUE, 
				dlgFind.m_nSelectItem, true);
		}
		else
			posFind = g_pCardSet->FindCard(dlgFind.m_strFind, FALSE, 0, true);

		if (dlgFind.m_strFind.GetLength() > 0)
			m_strPrevFind = dlgFind.m_strFind;

		if (posFind == NULL)
		{
			CString strTemp;
			strTemp.LoadString(IDS_NOT_FOUND);
			CString strMsg;
			strMsg.Format(strTemp, dlgFind.m_strFind);
			MessageBox(strMsg, AfxGetAppName(), MB_OK | MB_ICONINFORMATION);
		}
		else
		{
			m_pStrokeView->Clear();
			m_pCurrentCard = g_pCardSet->GetCard();
			InvalidateRect(NULL);
		}
	}
}



BOOL CChildView::OnEraseBkgnd(CDC* pDC) 
{
	CRect rcClient;
	GetClientRect(&rcClient);
	pDC->FillSolidRect(rcClient, m_rgbBack);
	
	//return CWnd ::OnEraseBkgnd(pDC);
	return FALSE;
}



void CChildView::SaveSetting()
{
	HKEY hKey;
	DWORD dwDisposition ;
	if (ERROR_SUCCESS == RegCreateKeyEx( HKEY_LOCAL_MACHINE, REG_PATH, 0 , 
		NULL, 0, 0, NULL, &hKey, &dwDisposition))
	{
		//ֱ 
		RegSetValueEx(hKey, REG_VALUE_LAST_FILE, 0, REG_SZ,
			(const BYTE *)((LPCTSTR)g_strCardFile), 
			sizeof(TCHAR) * ( g_strCardFile.GetLength() + 1) );

		//  
		DWORD dwValue = (DWORD)m_bShowStrokeView;
		RegSetValueEx(hKey, REG_VALUE_STROKE_VIEW, 0, REG_DWORD, 
			(const BYTE *)&dwValue, sizeof(DWORD));

		//  
		dwValue = (DWORD)m_bShowDictionaryView;
		RegSetValueEx(hKey, REG_VALUE_DICTIONARY_VIEW, 0, REG_DWORD, 
			(const BYTE *)&dwValue, sizeof(DWORD));

		//   ̺
		dwValue = (DWORD)m_bShowStatusIcon;
		RegSetValueEx(hKey, REG_VALUE_STATUS_ICON, 0, REG_DWORD, 
			(const BYTE *)&dwValue, sizeof(DWORD));		

		//WordWrap ó 
		dwValue = (DWORD)m_bWordWrap;
		RegSetValueEx(hKey, REG_VALUE_WORD_WRAP, 0, REG_DWORD, 
			(const BYTE *)&dwValue, sizeof(DWORD));

		//ϱ忡   
		dwValue = (DWORD)m_bSeqMemoMode;
		RegSetValueEx(hKey, REG_VALUE_SEQ_MEMO_MODE, 0, REG_DWORD, 
			(const BYTE *)&dwValue, sizeof(DWORD));		

		//ð  
		dwValue = m_uiTimerLimit;
		RegSetValueEx(hKey, REG_VALUE_TIME_LIMIT, 0, REG_DWORD, 
			(const BYTE *)&dwValue, sizeof(DWORD));

		//Background Color
		dwValue = (DWORD)m_rgbBack;
		RegSetValueEx(hKey, REG_VALUE_BACK_COLOR, 0, REG_DWORD,
			(const BYTE*)&dwValue, sizeof(DWORD));

		//Pen Color
		dwValue = (DWORD)m_pStrokeView->GetPenColor();
		RegSetValueEx(hKey, REG_VALUE_PEN_COLOR, 0, REG_DWORD,
			(const BYTE*)&dwValue, sizeof(DWORD));

		//Pen Width
		dwValue = (DWORD)m_pStrokeView->GetPenWidth();
		RegSetValueEx(hKey, REG_VALUE_PEN_WIDTH, 0, REG_DWORD,
			(const BYTE*)&dwValue, sizeof(DWORD));

		//Button Height
		dwValue = m_dwButtonSize;
		RegSetValueEx(hKey, REG_VALUE_BUTTON_SIZE, 0, REG_DWORD,
			(const BYTE*)&dwValue, sizeof(DWORD));

		//Program Mode
		dwValue = (DWORD)g_ProgramMode;
		RegSetValueEx(hKey, REG_VALUE_PROGRAM_MODE, 0, REG_DWORD,
			(const BYTE*)&dwValue, sizeof(DWORD));

		RegCloseKey(hKey);
	}
}

void CChildView::LoadSetting()
{
	HKEY hKey;
	if (ERROR_SUCCESS == RegOpenKeyEx(HKEY_LOCAL_MACHINE, REG_PATH, 0, 0, &hKey))
	{
		TCHAR szFileName[MAX_PATH];
		DWORD dwType = REG_SZ;
		DWORD dwSize = MAX_PATH;
		if (ERROR_SUCCESS == RegQueryValueEx(hKey, REG_VALUE_LAST_FILE, NULL, 
			&dwType, (LPBYTE)szFileName, &dwSize) )
		{
			if (IsFileExist(szFileName) == TRUE)
				g_strCardFile = szFileName;
		}

		//  
		DWORD dwValue;
		dwSize = sizeof(DWORD);

		if (ERROR_SUCCESS == RegQueryValueEx(hKey, REG_VALUE_STROKE_VIEW, NULL, 
			&dwType, (LPBYTE)&dwValue, &dwSize))
			m_bShowStrokeView = (BOOL)dwValue;
		else
			m_bShowStrokeView = TRUE;

		//    -- 2007-02-02 ߰
		if (ERROR_SUCCESS == RegQueryValueEx(hKey, REG_VALUE_DICTIONARY_VIEW, NULL, 
			&dwType, (LPBYTE)&dwValue, &dwSize))
			m_bShowDictionaryView = (BOOL)dwValue;
		else
			m_bShowDictionaryView = TRUE;

		//    
		if (ERROR_SUCCESS == RegQueryValueEx(hKey, REG_VALUE_STATUS_ICON, NULL, 
			&dwType, (LPBYTE)&dwValue, &dwSize))
			m_bShowStatusIcon = (BOOL)dwValue;
		else
			m_bShowStatusIcon = TRUE;

		//Word-wrap ó  
		if (ERROR_SUCCESS == RegQueryValueEx(hKey, REG_VALUE_WORD_WRAP, NULL, 
			&dwType, (LPBYTE)&dwValue, &dwSize))
			m_bWordWrap = (BOOL)dwValue;
		else
			m_bWordWrap = TRUE;

		//ϱ忡   
		if (ERROR_SUCCESS == RegQueryValueEx(hKey, REG_VALUE_SEQ_MEMO_MODE, NULL, 
			&dwType, (LPBYTE)&dwValue, &dwSize))
			m_bSeqMemoMode = (BOOL)dwValue;
		else
			m_bSeqMemoMode = FALSE;

		//Ÿ̸ 
		if (ERROR_SUCCESS == RegQueryValueEx(hKey, REG_VALUE_TIME_LIMIT, NULL, 
			&dwType, (LPBYTE)&dwValue, &dwSize))
			m_uiTimerLimit = dwValue;
		else
			m_uiTimerLimit = 0;
		
		//Background Color
		if (ERROR_SUCCESS == RegQueryValueEx(hKey, REG_VALUE_BACK_COLOR, NULL,
			&dwType, (LPBYTE)&dwValue, &dwSize) )
			m_rgbBack = (COLORREF)(dwValue);
		else
			m_rgbBack = RGB(255, 255, 255);

		//Pen Color
		if (ERROR_SUCCESS == RegQueryValueEx(hKey, REG_VALUE_PEN_COLOR, NULL,
			&dwType, (LPBYTE)&dwValue, &dwSize) )
			m_pStrokeView->SetPenColor((COLORREF)(dwValue));

		//Pen Width
		if (ERROR_SUCCESS == RegQueryValueEx(hKey, REG_VALUE_PEN_WIDTH, NULL,
			&dwType, (LPBYTE)&dwValue, &dwSize) )
			m_pStrokeView->SetPenWidth((dwValue));

		//Button Height
		if (ERROR_SUCCESS == RegQueryValueEx(hKey, REG_VALUE_BUTTON_SIZE, NULL,
			&dwType, (LPBYTE)&dwValue, &dwSize) )
			m_dwButtonSize = dwValue;

		//  
		if (ERROR_SUCCESS == RegQueryValueEx(hKey, REG_VALUE_PROGRAM_MODE, NULL,
			&dwType, (LPBYTE)&dwValue, &dwSize) )
			g_ProgramMode = (PROGRAM_MODE)dwValue;
		
		RegCloseKey(hKey);
	}
}


BOOL ConvertNewLine(CString& strWord)
{
	int nIndex;
	BOOL bNoMore = FALSE;
	BOOL bFound = FALSE;
	do
	{
		nIndex = strWord.Find(_T("/n"));
		if (nIndex == -1)
			bNoMore = TRUE;
		else
		{
			strWord = strWord.Left(nIndex) + CString("\n") + strWord.Mid(nIndex + 2);
			bFound = TRUE;
		}
	} while( bNoMore == FALSE);

	return bFound;
}



