// ChildView.h : interface of the CChildView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_CHILDVIEW_H__43094172_A959_4D7D_92FA_EA863D3001C7__INCLUDED_)
#define AFX_CHILDVIEW_H__43094172_A959_4D7D_92FA_EA863D3001C7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CCard;
class CCardSet;
class CTemplate;
class CStrokeView;
class CQuiz;
class CQuizList;

/////////////////////////////////////////////////////////////////////////////
// CChildView window

class CChildView : public CWnd
{
// Construction
public:
	CChildView();
// Attributes
private:
	CStrokeView* m_pStrokeView;	
	CQuizList* m_pQuizList;
	CCard* m_pCurrentCard;		// ̴  ϱϰ ִ ī带 ƮѴ.

	BOOL m_bWordWrap;
	BOOL m_bShowStrokeView;
	BOOL m_bShowDictionaryView;		// 2007-02-02 ߰
	BOOL m_bShowStatusIcon;
	BOOL m_bSeqMemoMode;
	BOOL m_bQuestion;
	UINT m_uiTimerLimit;
	UINT m_uiTimerCount;
	CFont m_fntItem[MAX_ITEM];
	CFont m_fntTimerLimit;
	CFont m_fntQuiz;
	CBitmap m_bmpOMark;
	CBitmap m_bmpXMark;
	CBitmap m_bmpQMark;
	CBitmap m_bmpAMark;
	CBitmap m_bmpMMark;

	CButton m_btnShow;
	CButton m_btnRight;
	CButton m_btnWrong;

	CButton m_btnPrev;
	CButton m_btnNext;
	CButton m_btnExam[NUM_MAX_EXAMPLE];
	CButton m_btnPass;

	COLORREF m_rgbBack;

	CButton m_btnStop;
	BOOL m_bAutoProgress;
	BOOL m_bAutoRepeat;

	DWORD m_dwButtonSize;

	CString m_strPrevFind;

	CEdit *m_pEditItem[MAX_ITEM];		// 2007-02-02 ߰.

// Operations
public:
	void UpdateButtonState();
	void ChangeMode(PROGRAM_MODE NewMode, bool bInit = false);
	void MoveToNextQuiz();
	void MoveToNextCard();
	void MoveToPrevCard();
	void ShowAnswerCard();
	void AnswerOnCard(BOOL bRight);
	void AnswerOnQuiz(int nAnswer);

	BOOL IsShowStrokeView() const { return m_bShowStrokeView; }
	BOOL IsShowDictionaryView() const { return m_bShowDictionaryView; }
	UINT GetTimerLimit() const { return m_uiTimerLimit; }
	BOOL IsWordWrap() const { return m_bWordWrap; }

	void LoadSetting();
	void SaveSetting();

	BOOL BuildFonts();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CChildView)
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL


// Implementation
public:
	virtual ~CChildView();
	void SetupQuiz() 
	{
		OnSetupQuiz();
	}
	// Generated message map functions
protected:
	//{{AFX_MSG(CChildView)
	afx_msg void OnPaint();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnTimer10sec();
	afx_msg void OnTimer20sec();
	afx_msg void OnTimer30sec();
	afx_msg void OnTimer5sec();
	afx_msg void OnTimer60sec();
	afx_msg void OnTimerUnlimit();
	afx_msg void OnDestroy();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnEditCard();
	afx_msg void OnItemAttr();
	afx_msg void OnStrokeView();
	afx_msg void OnDictionaryView();
	afx_msg void OnDelCard();
	afx_msg void OnAddCard();
	afx_msg void OnMoveCard();
	afx_msg void OnAddBookmark();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSetupQuiz();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnOptions();
	afx_msg void OnAutoProgress();
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnEditFind();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	BOOL CreateButtons();
	BOOL CreateStrokeView();

	BOOL BuildQuizFont();

	void DrawCounter(CDC* pDC);
	void DrawStatus(CDC* pDC);
	void DrawCard(CDC* pDC, CCard* pCard, int& yStart);
	void DrawExample(CDC* pDC, int yStart);
	int DrawCardText(CDC* pDC, LPCTSTR szWord, RECT* prcText, UINT uiAlign);
	void DrawQuizResult(CDC* pDC, int yStart);
	void ChangeTimer(UINT uiTimer);
	BOOL CheckQuizSetting();
	void DrawQAMark(CDC* pDC, int yStart, BOOL bQuestion);
	void DrawMMark(CDC* pDC, int yStart);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft eMbedded Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CHILDVIEW_H__43094172_A959_4D7D_92FA_EA863D3001C7__INCLUDED_)
