// DispItem.cpp: implementation of the CDispItem class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MemoKing.h"
#include "DispItem.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
CCard::CCard()
{
	for (int i = 0 ; i < MAX_ITEM; i++)
	{
		m_szWord[i] = NULL;
	}
}

CCard::~CCard()
{
	for (int i = 0 ; i < MAX_ITEM; i++)
	{
		if (m_szWord[i] != NULL)
		{
			delete m_szWord[i];
			m_szWord[i] = NULL;
		}
	}
}

LPCTSTR CCard::GetWord(UINT nIndex) const
{
	ASSERT(nIndex < MAX_ITEM);
	return m_szWord[nIndex];
}

void CCard::SetWord(UINT nIndex, LPCTSTR szWord)
{
	ASSERT(nIndex < MAX_ITEM);

	if (m_szWord[nIndex] != NULL)
		delete m_szWord[nIndex];			
	int nLength = lstrlen(szWord);
	m_szWord[nIndex] = new TCHAR[nLength + 1];
	ZeroMemory(m_szWord[nIndex], nLength + 1);
	lstrcpy(m_szWord[nIndex], szWord);
}


CCardSet::CCardSet()
{
	CString strName;
	for (UINT i = 0; i < MAX_ITEM; i++)
	{
		strName.Format(_T("Item%d"), i);
		m_pItemAttrs[i] = new CItemAttr(strName, i);
	}
}

CCardSet::~CCardSet()
{
	POSITION posCardList = m_lstCard.GetHeadPosition();
	for (int i = 0; i < m_lstCard.GetCount(); i++)
	{
		CCard* pCard = m_lstCard.GetNext(posCardList);
		if (pCard != NULL)
		{
			delete pCard;
			pCard = NULL;
		}
	}

	for (i = 0; i < MAX_ITEM; i++)
		delete m_pItemAttrs[i] ;
}

UINT CCardSet::GetNumCards() const
{
	return m_lstCard.GetCount();
}

void CCardSet::InsertCard(CCard* pCard)
{
	ASSERT(pCard != NULL);
	m_lstCard.AddTail((CCard*)pCard);
}

void CCardSet::MoveToFirst()
{
	m_posCardList = m_lstCard.GetHeadPosition();
}

bool CCardSet::MoveNext()
{
	if (m_posCardList == NULL)
		return false;
	m_lstCard.GetNext(m_posCardList);
	return true;
}

CCard* CCardSet::GetCard() const
{
	return m_lstCard.GetAt(m_posCardList);
}

