// DlgAutoProgress.cpp : implementation file
//

#include "stdafx.h"
#include "MemoKing.h"
#include "DlgAutoProgress.h"
#include "define.h"
#include "Utils.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDlgAutoProgress dialog


CDlgAutoProgress::CDlgAutoProgress(BOOL bStudyMode, CWnd* pParent /*=NULL*/)
	: CDialog(CDlgAutoProgress::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgAutoProgress)
	m_dwTimeInterval = 0;
	m_bRepeat = FALSE;
	//}}AFX_DATA_INIT
	m_bStudyMode = bStudyMode;
	m_bStartFromFirst = TRUE;
}


void CDlgAutoProgress::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgAutoProgress)
	DDX_Text(pDX, IDC_TIME_INTERVAL, m_dwTimeInterval);
	DDX_Check(pDX, IDC_REPEAT, m_bRepeat);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgAutoProgress, CDialog)
	//{{AFX_MSG_MAP(CDlgAutoProgress)
	ON_BN_CLICKED(IDC_START_FROM_FIRST, OnStartFromFirst)
	ON_BN_CLICKED(IDC_START_FROM_CURRENT, OnStartFromCurrent)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDlgAutoProgress message handlers
BOOL CDlgAutoProgress::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	SendDlgItemMessage(IDC_TIME_INTERVAL_SPIN,UDM_SETRANGE,0,MAKELONG(600,1));

	LoadSetting();

	if (m_bStudyMode == FALSE)
	{
		CWnd* pButton;
		pButton = GetDlgItem(IDC_REPEAT);
		if (pButton != NULL)
			pButton->EnableWindow(FALSE);
		pButton = GetDlgItem(IDC_START_FROM_FIRST);
		if (pButton != NULL)
			pButton->EnableWindow(FALSE);
		pButton = GetDlgItem(IDC_START_FROM_CURRENT);
		if (pButton != NULL)
			pButton->EnableWindow(FALSE);
	}
	else
	{
		CButton* pButton;
		if (m_bStartFromFirst == TRUE)
		{
			pButton = (CButton*)GetDlgItem(IDC_START_FROM_FIRST);
			if (pButton != NULL)
				pButton->SetCheck(BST_CHECKED);
		}
		else
		{
			pButton = (CButton*)GetDlgItem(IDC_START_FROM_CURRENT);
			if (pButton != NULL)
				pButton->SetCheck(BST_CHECKED);
		}
	}

	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDlgAutoProgress::OnStartFromFirst() 
{
	m_bStartFromFirst = TRUE;
}

void CDlgAutoProgress::OnStartFromCurrent() 
{
	m_bStartFromFirst = FALSE;
}

void CDlgAutoProgress::LoadSetting()
{
	HKEY hKey;
	if (ERROR_SUCCESS == RegOpenKeyEx(HKEY_LOCAL_MACHINE, REG_PATH, 0, 0, &hKey))
	{
		//ð  
		DWORD dwValue;
		DWORD dwType;
		DWORD dwSize = sizeof(DWORD);

		if (ERROR_SUCCESS == RegQueryValueEx(hKey, REG_VALUE_AUTO_TIME_INTERVAL, NULL, 
			&dwType, (LPBYTE)&dwValue, &dwSize))
			m_dwTimeInterval = dwValue;
		else
			m_dwTimeInterval = 5;

		if (m_bStudyMode == TRUE)
		{
			//ݺ  
			if (ERROR_SUCCESS == RegQueryValueEx(hKey, REG_VALUE_AUTO_REPEAT, NULL, 
				&dwType, (LPBYTE)&dwValue, &dwSize))
				m_bRepeat = (BOOL)dwValue;
			else
				m_bRepeat = TRUE;

			//ó   
			if (ERROR_SUCCESS == RegQueryValueEx(hKey, REG_VALUE_ATUO_START_FROM_FIRST, NULL, 
				&dwType, (LPBYTE)&dwValue, &dwSize))
				m_bStartFromFirst = (BOOL)dwValue;
			else
				m_bStartFromFirst = TRUE;
		}
		RegCloseKey(hKey);
	}


}

void CDlgAutoProgress::OnOK() 
{
	UpdateData(TRUE);
	if (m_dwTimeInterval < 0 || m_dwTimeInterval > 600)
	{
		CString strMsg;
		strMsg.LoadString(IDS_INVALID_TIME_INTERVAL);
		MessageBox(strMsg, AfxGetAppName(), MB_OK | MB_ICONWARNING);
		return;
	}
	SaveSetting();
	
	CDialog::OnOK();
}


void CDlgAutoProgress::SaveSetting()
{
	HKEY hKey;
	DWORD dwDisposition ;
	DWORD dwValue;
	if (ERROR_SUCCESS == RegCreateKeyEx( HKEY_LOCAL_MACHINE, REG_PATH, 0 , 
		NULL, 0, 0, NULL, &hKey, &dwDisposition))
	{
		//ð  
		RegSetValueEx(hKey, REG_VALUE_AUTO_TIME_INTERVAL, 0, REG_DWORD, 
			(const BYTE *)&m_dwTimeInterval, sizeof(DWORD));

		if (m_bStudyMode == TRUE)
		{
			//ݺ  
			dwValue = (DWORD)m_bRepeat;
			RegSetValueEx(hKey, REG_VALUE_AUTO_REPEAT, 0, REG_DWORD, 
				(const BYTE *)&dwValue, sizeof(DWORD));

			dwValue = (DWORD)m_bStartFromFirst;
			RegSetValueEx(hKey, REG_VALUE_ATUO_START_FROM_FIRST, 0, REG_DWORD, 
				(const BYTE *)&dwValue, sizeof(DWORD));
		}

		RegCloseKey(hKey);
	}	
}

void CDlgAutoProgress::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	CString strMsg;
	strMsg.LoadString(IDS_AUTO_PROGRESS);
	PaintHeader(dc, strMsg);

}
