// FindDlg.cpp : implementation file
//

#include "stdafx.h"
#include "define.h"
#include "MemoKing.h"
#include "FindDlg.h"
#include "Utils.h"
#include "Template.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFindDlg dialog


CFindDlg::CFindDlg(CTemplate* pTemplate, CWnd* pParent /*=NULL*/)
	: CDialog(CFindDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFindDlg)
	m_strFind = _T("");
	m_bSelectItemOnly = FALSE;
	//}}AFX_DATA_INIT
	m_pTemplate = pTemplate;
}


void CFindDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFindDlg)
	DDX_Control(pDX, IDC_SELECT_ITEM, m_wndSelectItem);
	DDX_Text(pDX, IDC_FIND_TEXT, m_strFind);
	DDX_Check(pDX, IDC_SELECT_ITEM_ONLY, m_bSelectItemOnly);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFindDlg, CDialog)
	//{{AFX_MSG_MAP(CFindDlg)
	ON_BN_CLICKED(IDC_SELECT_ITEM_ONLY, OnSelectItemOnly)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFindDlg message handlers

void CFindDlg::OnSelectItemOnly() 
{
	UpdateData(TRUE);
	GetDlgItem(IDC_SELECT_ITEM)->EnableWindow(m_bSelectItemOnly == TRUE);
}

void CFindDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	CString strMsg;
	strMsg.LoadString(IDS_FIND_CARD);
	::PaintHeader(dc, strMsg);	
}


BOOL CFindDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	GetDlgItem(IDC_SELECT_ITEM)->EnableWindow(m_bSelectItemOnly == TRUE);

	for (int i = 0; i < MAX_ITEM; i++)
		m_wndSelectItem.InsertString(i, m_pTemplate->GetItemName(i));
	m_nSelectItem = 0;
	m_wndSelectItem.SetCurSel(m_nSelectItem);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CFindDlg::OnOK() 
{
	m_nSelectItem = m_wndSelectItem.GetCurSel();
	CDialog::OnOK();
}
