// GotoCardDlg.cpp : implementation file
//
#include "stdafx.h"
#include "resource.h"
#include "define.h"
#include "GotoCardDlg.h"
#include "Card.h"
#include "Utils.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGotoCardDlg dialog


CGotoCardDlg::CGotoCardDlg(CCardSet* pCardSet, CWnd* pParent /*=NULL*/)
	: CDialog(CGotoCardDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGotoCardDlg)
	m_nCardNum = pCardSet->GetCardIndex() + 1;
	//}}AFX_DATA_INIT
	m_pCardSet = pCardSet;
}


void CGotoCardDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGotoCardDlg)
	DDX_Text(pDX, IDC_CARD_NUM, m_nCardNum);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGotoCardDlg, CDialog)
	//{{AFX_MSG_MAP(CGotoCardDlg)
	ON_BN_CLICKED(IDC_BOOKMARK_CARD, OnBookmarkCard)
	ON_BN_CLICKED(IDC_FIRST_CARD, OnFirstCard)
	ON_BN_CLICKED(IDC_LAST_CARD, OnLastCard)
	ON_BN_CLICKED(IDC_USERINPUT_CARD, OnUserinputCard)
	ON_WM_PAINT()
	ON_EN_SETFOCUS(IDC_CARD_NUM, OnSetfocusCardNum)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGotoCardDlg message handlers

void CGotoCardDlg::OnOK() 
{
	switch(m_Sel)
	{
		case GOTO_BOOKMARK:
		{
			POSITION posGoto = m_pCardSet->GetBookmarkPos();
			if (posGoto == NULL)
			{
				CString strMsg;
				strMsg.LoadString(IDS_NO_BOOKMAR);
				MessageBox(strMsg, AfxGetAppName(), MB_OK | MB_ICONERROR);
				return;
			}
			m_pCardSet->MoveToPosition(posGoto);
			break;
		}

		case GOTO_FIRST:
			m_pCardSet->MoveToFirst();
			break;

		case GOTO_LAST:
			m_pCardSet->MoveToLast();
			break;

		case GOTO_USER:
		{
			UpdateData(TRUE);
			if (m_nCardNum <= 0 || m_nCardNum > m_pCardSet->GetNumCards())
			{
				CString strMsg;
				strMsg.LoadString(IDS_WRONG_CARD_NUMBER);
				MessageBox(strMsg, AfxGetAppName(), MB_OK | MB_ICONERROR);
				return;
			}
			m_pCardSet->MoveToIndex(m_nCardNum - 1);
			break;
		}
	}
	CDialog::OnOK();
}

BOOL CGotoCardDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	CButton* pButton = (CButton*) GetDlgItem(IDC_BOOKMARK_CARD);
	pButton->SetCheck(TRUE);
	m_Sel = GOTO_BOOKMARK;
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CGotoCardDlg::OnBookmarkCard() 
{
	m_Sel = GOTO_BOOKMARK;
	//DisableInputBox();
}

void CGotoCardDlg::OnFirstCard() 
{
	m_Sel = GOTO_FIRST;
	//DisableInputBox();
}

void CGotoCardDlg::OnLastCard() 
{
	m_Sel = GOTO_LAST;
	//DisableInputBox();
}

void CGotoCardDlg::OnUserinputCard() 
{
	m_Sel = GOTO_USER;
	CWnd* pWnd = GetDlgItem(IDC_CARD_NUM);
	pWnd->EnableWindow(TRUE);
	pWnd->SetFocus();
	((CEdit*)pWnd)->SetSel(0, -1);
#ifdef _WIN32_WCE_PSPC
	SHSipPreference(GetSafeHwnd(), SIP_UP);
#endif
}

void CGotoCardDlg::DisableInputBox()
{
	CWnd* pWnd = GetDlgItem(IDC_CARD_NUM);
	pWnd->EnableWindow(FALSE);
#ifdef _WIN32_WCE_PSPC
	SHSipPreference(GetSafeHwnd(), SIP_DOWN);
#endif
}

void CGotoCardDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	CString strMsg;
	strMsg.LoadString(IDS_MOVE_CARD);
	::PaintHeader(dc, strMsg);	
	// Do not call CDialog::OnPaint() for painting messages
}

void CGotoCardDlg::OnSetfocusCardNum() 
{
#ifdef _WIN32_WCE_PSPC
	SHSipPreference(GetSafeHwnd(), SIP_UP);
#endif
	CWnd* pWnd = GetDlgItem(IDC_CARD_NUM);
	((CEdit*)pWnd)->SetSel(0, -1);
	m_Sel = GOTO_USER;
	CButton* pButton = (CButton*)GetDlgItem(IDC_USERINPUT_CARD);
	pButton->SetCheck(BST_CHECKED);

	pButton = (CButton*)GetDlgItem(IDC_BOOKMARK_CARD);
	pButton->SetCheck(BST_UNCHECKED);
	pButton = (CButton*)GetDlgItem(IDC_FIRST_CARD);
	pButton->SetCheck(BST_UNCHECKED);
	pButton = (CButton*)GetDlgItem(IDC_LAST_CARD);
	pButton->SetCheck(BST_UNCHECKED);
}
