// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "define.h"
#include "MemoKing.h"
#include "MainFrm.h"
#include "Card.h"
#include "Template.h"
#include "QuizSetupDlg.h"
#include "Quiz.h" 
#include "CardFile.h"
#include "Utils.h"
#include <Winuser.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define PSPC_TOOLBAR_HEIGHT 24

const DWORD dwAdornmentFlags = 0; // exit button

PROGRAM_MODE g_ProgramMode;
CCardSet* g_pCardSet = NULL;
CTemplate* g_pTemplate = NULL;
CQuizSetting* g_pQuizSetting = NULL;
CString g_strCardFile;

CMainFrame* h_main;				// 2007-02-03 Edit control   ߰..


/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	ON_WM_INITMENUPOPUP()
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_COMMAND(ID_MEMORIZE_MODE, OnMemorizeMode)
	ON_COMMAND(ID_STUDY_MODE, OnStudyMode)
	ON_COMMAND(ID_QUIZ_MODE, OnQuizMode)
	ON_COMMAND(ID_RESET_MEMORY_STATUS, OnResetMemoryStatus)
	ON_COMMAND(ID_CONVERT, OnConvert)
	ON_COMMAND(ID_IMPORT_TEMPLETE, OnImportTemplete)
	ON_COMMAND(ID_EXPORT_TEMPLETE, OnExportTemplete)
	ON_COMMAND(ID_FILE_EXPORT, OnFileExport)
	ON_COMMAND(ID_CONVERT_ADD, OnConvertAdd)
	ON_WM_DESTROY()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	g_ProgramMode = STUDY_MODE;
	g_pCardSet = new CCardSet();
	g_pTemplate = new CTemplate();
	g_pQuizSetting= new CQuizSetting();
	m_strLastDir = _T(""); 
}

CMainFrame::~CMainFrame()
{
	if (g_pCardSet != NULL)
	{
		delete g_pCardSet;
		g_pCardSet = NULL;
	}
	if (g_pTemplate != NULL)
	{
		delete g_pTemplate;
		g_pTemplate = NULL;
	}
	if (g_pQuizSetting != NULL)
	{
		delete g_pQuizSetting;
		g_pQuizSetting = NULL;
	}
}

void CMainFrame::AutoSaveFile()
{
	if (g_pCardSet->GetNumCards() > 0)
	{
		int nIndex = g_strCardFile.ReverseFind(_T('.'));
		g_strCardFile = g_strCardFile.Left(nIndex) + _T(".mmk");
		if (g_pCardSet->IsModified() || g_pTemplate->IsModified() || g_pQuizSetting->IsModified())
		{
			AfxGetApp()->DoWaitCursor(1);
			CCardFile::SaveFile(g_strCardFile, g_pCardSet, g_pTemplate, g_pQuizSetting);
			AfxGetApp()->DoWaitCursor(-1);
		}
		else //ī    Footer 
		{
			AfxGetApp()->DoWaitCursor(1);
			CCardFile::SaveHeader(g_strCardFile, g_pCardSet);
			AfxGetApp()->DoWaitCursor(-1);
		}
	}
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	/*
	TCHAR szFolder[MAX_PATH];
	SHGetSpecialFolderPath(hwnd,szFolder,CSIDL_PERSONAL,TRUE);
	DOCLISTCREATE dlc;
	ZeroMemory(&dlc, sizeof(DOCLISTCREATE));
	dlc.dwStructSize = sizeof(DOCLISTCREATE);
	dlc.hwndParent = GetSafeHwnd();
	//dlc.pszFolder = _T("\\MyDocument");
	dlc.pszFolder = szFolder;
	//dlc.pstrFilter = L"Text\0*.txt\0";
	dlc.pstrFilter = _T("MemoKing Files (*.mk)\0*.mk\0Text Files (*.txt)\0*.txt\0");
	dlc.wId = 0;
	DocList_Create(&dlc);
	*/

	// create a view to occupy the client area of the frame
	if (!m_wndView.Create(NULL, NULL, AFX_WS_DEFAULT_VIEW,
		CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}
	m_wndView.LoadSetting();
	HKEY hKey;
	if (ERROR_SUCCESS == RegOpenKeyEx(HKEY_LOCAL_MACHINE, REG_PATH, 0, 0, &hKey))
	{
		TCHAR szFilePath[MAX_PATH];
		DWORD dwType = REG_SZ;
		DWORD dwSize = MAX_PATH;
		if (ERROR_SUCCESS == RegQueryValueEx(hKey, REG_VALUE_LAST_PATH, NULL, 
			&dwType, (LPBYTE)szFilePath, &dwSize) )
		{
			m_strLastDir = szFilePath;
		}
		RegCloseKey(hKey);
	}

	if (m_strLastDir.GetLength() == 0)
	{
		if (g_strCardFile.GetLength() > 0) 
		{
			int nPos = g_strCardFile.ReverseFind(_T('\\'));
			m_strLastDir = g_strCardFile.Left(nPos);
		}
	}

#ifdef _WIN32_WCE_PSPC
	m_wndCommandBar.m_bShowSharedNewButton = FALSE;
#endif
	if(!m_wndCommandBar.Create(this) ||
	   !m_wndCommandBar.InsertMenuBar(IDR_MAINFRAME) ||
	   !m_wndCommandBar.AddAdornments() ||
	   !m_wndCommandBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create CommandBar\n");
		return -1;      // fail to create
	}

	m_wndCommandBar.SetBarStyle(m_wndCommandBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_FIXED);

	CWinApp* pApp = ::AfxGetApp();

	if (pApp->m_lpCmdLine[0] == _T('\0'))
	{
		if (g_strCardFile.GetLength() > 0)
			OpenDataFile(g_strCardFile);
		else
			OnFileOpen();
	}
	else
	{
		// Open a file passed as the first command line parameter.
		OpenDataFile(pApp->m_lpCmdLine);
	}

	h_main = (CMainFrame*) this;		// 2007-02-03 ߰

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs


	cs.lpszClass = AfxRegisterWndClass(0);
	return TRUE;
}
 
/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers
void CMainFrame::OnSetFocus(CWnd* pOldWnd)
{
	// forward focus to the view window
	m_wndView.SetFocus();
}

BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// let the view have first crack at the command
	if (m_wndView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// otherwise, do default handling
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

void CMainFrame::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu) 
{
	CFrameWnd::OnInitMenuPopup(pPopupMenu, nIndex, bSysMenu);

	UINT uiSetting = MF_ENABLED;
	if (g_pCardSet->GetNumCards() == 0)
		uiSetting = MF_GRAYED;

	pPopupMenu->EnableMenuItem(ID_EXPORT_TEMPLETE, MF_BYCOMMAND | uiSetting);
	pPopupMenu->EnableMenuItem(ID_FILE_EXPORT, MF_BYCOMMAND | uiSetting);
	
	pPopupMenu->EnableMenuItem(ID_ITEM_ATTR, MF_BYCOMMAND | uiSetting);
	pPopupMenu->EnableMenuItem(ID_SETUP_QUIZ, MF_BYCOMMAND | uiSetting);
	pPopupMenu->EnableMenuItem(ID_RESET_MEMORY_STATUS, MF_BYCOMMAND | uiSetting);
	
	UINT uiEditCard;
	UINT uiStrokeView;
	UINT uiTimer;
	switch(g_ProgramMode)
	{
		case STUDY_MODE:
			uiEditCard = MF_ENABLED;
			pPopupMenu->EnableMenuItem(ID_EDIT_CARD, MF_BYCOMMAND | MF_ENABLED);
			pPopupMenu->EnableMenuItem(ID_AUTO_PROGRESS, MF_BYCOMMAND | MF_ENABLED);
			uiStrokeView = MF_ENABLED;
			uiTimer = MF_GRAYED;
			pPopupMenu->CheckMenuRadioItem(
				ID_STUDY_MODE, ID_QUIZ_MODE, ID_STUDY_MODE, MF_BYCOMMAND);
			break;
		case MEMORIZE_MODE:
			uiEditCard = MF_GRAYED;
			pPopupMenu->EnableMenuItem(ID_EDIT_CARD, MF_BYCOMMAND | MF_ENABLED);
			pPopupMenu->EnableMenuItem(ID_AUTO_PROGRESS, MF_BYCOMMAND | MF_ENABLED);
			uiStrokeView = MF_ENABLED;
			uiTimer = MF_ENABLED;
			pPopupMenu->CheckMenuRadioItem(
				ID_STUDY_MODE, ID_QUIZ_MODE, ID_MEMORIZE_MODE, MF_BYCOMMAND);
			break;
		case QUIZ_MODE:
			uiEditCard = MF_GRAYED;
			pPopupMenu->EnableMenuItem(ID_EDIT_CARD, MF_BYCOMMAND | MF_GRAYED);
			pPopupMenu->EnableMenuItem(ID_AUTO_PROGRESS, MF_BYCOMMAND | MF_GRAYED);
			uiStrokeView = MF_GRAYED;
			uiTimer = MF_ENABLED;
			pPopupMenu->CheckMenuRadioItem(
				ID_STUDY_MODE, ID_QUIZ_MODE, ID_QUIZ_MODE, MF_BYCOMMAND);
			break;
	}

	pPopupMenu->EnableMenuItem(ID_ADD_CARD, MF_BYCOMMAND | uiEditCard);
	pPopupMenu->EnableMenuItem(ID_DEL_CARD, MF_BYCOMMAND | uiEditCard);
	pPopupMenu->EnableMenuItem(ID_MOVE_CARD, MF_BYCOMMAND | uiEditCard);
	pPopupMenu->EnableMenuItem(ID_ADD_BOOKMARK, MF_BYCOMMAND | uiEditCard);
	pPopupMenu->EnableMenuItem(ID_EDIT_FIND, MF_BYCOMMAND | uiEditCard);
	pPopupMenu->EnableMenuItem(ID_STROKE_VIEW, MF_BYCOMMAND | uiStrokeView);
	pPopupMenu->EnableMenuItem(ID_SETUP_QUIZ, MF_BYCOMMAND | uiStrokeView);

	pPopupMenu->EnableMenuItem(ID_TIMER_UNLIMIT, MF_BYCOMMAND | uiTimer);
	pPopupMenu->EnableMenuItem(ID_TIMER_5SEC, MF_BYCOMMAND | uiTimer);
	pPopupMenu->EnableMenuItem(ID_TIMER_10SEC, MF_BYCOMMAND | uiTimer);
	pPopupMenu->EnableMenuItem(ID_TIMER_20SEC, MF_BYCOMMAND | uiTimer);
	pPopupMenu->EnableMenuItem(ID_TIMER_30SEC, MF_BYCOMMAND | uiTimer);
	pPopupMenu->EnableMenuItem(ID_TIMER_60SEC, MF_BYCOMMAND | uiTimer);

	if (uiTimer == MF_ENABLED)
	{
		UINT uiTimerLimit = m_wndView.GetTimerLimit();
		UINT uiCheck;
		if (uiTimerLimit == 0)
			uiCheck = ID_TIMER_UNLIMIT;
		else if (uiTimerLimit == 5)
			uiCheck = ID_TIMER_5SEC;
		else if (uiTimerLimit == 10)
			uiCheck = ID_TIMER_10SEC;
		else if (uiTimerLimit == 20)
			uiCheck = ID_TIMER_20SEC;
		else if (uiTimerLimit == 30)
			uiCheck = ID_TIMER_30SEC;
		else if (uiTimerLimit == 60)
			uiCheck = ID_TIMER_60SEC;
		
		pPopupMenu->CheckMenuRadioItem(
			ID_TIMER_UNLIMIT, ID_TIMER_60SEC, uiCheck, MF_BYCOMMAND);
	}

	if (m_wndView.IsShowStrokeView())
		pPopupMenu->CheckMenuItem(ID_STROKE_VIEW, MF_BYCOMMAND | MF_CHECKED );
	else
		pPopupMenu->CheckMenuItem(ID_STROKE_VIEW, MF_BYCOMMAND | MF_UNCHECKED );

	if (m_wndView.IsShowDictionaryView())
		pPopupMenu->CheckMenuItem(ID_DICTIONARY_VIEW, MF_BYCOMMAND | MF_CHECKED );
	else
		pPopupMenu->CheckMenuItem(ID_DICTIONARY_VIEW, MF_BYCOMMAND | MF_UNCHECKED );

	if (m_wndView.IsWordWrap())
		pPopupMenu->CheckMenuItem(ID_WORDWRAP, MF_BYCOMMAND | MF_CHECKED );
	else
		pPopupMenu->CheckMenuItem(ID_WORDWRAP, MF_BYCOMMAND | MF_UNCHECKED );
}


void CMainFrame::OnFileOpen() 
{
	TCHAR szFileName[MAX_PATH];
	memset(szFileName, 0, sizeof(TCHAR)* MAX_PATH);

	BOOL fRet;
	OPENFILENAME ofn;
	memset(&(ofn), 0, sizeof(ofn));

	ofn.lStructSize	= sizeof(ofn);
	ofn.hwndOwner   = GetSafeHwnd();
	ofn.lpstrFile   = szFileName;
	ofn.nMaxFile    = MAX_PATH;	
	ofn.lpstrTitle  = _T("ϱ  ..");
	ofn.lpstrFilter = _T("ϱ  (*.mmk)\0*.mmk\0  (*.*)\0*.*\0\0");
	if (m_strLastDir.GetLength() >= 0)
		ofn.lpstrInitialDir = m_strLastDir;
	else
		ofn.lpstrInitialDir = NULL;

	BOOL (*gsGetOpenFileName)(OPENFILENAME*) = NULL;

	HINSTANCE hInst = LoadLibrary(_T("gsgetfile.dll"));
	if (hInst) 
	{
		(FARPROC&)gsGetOpenFileName = GetProcAddress(hInst, _T("gsGetOpenFileName"));
	}

	if (gsGetOpenFileName) 
	{
		ofn.Flags       = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
		fRet = gsGetOpenFileName(&ofn);
	}
	else 
	{
		ofn.Flags       = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
		fRet = GetOpenFileName(&ofn);
	}

	if (hInst) 
		FreeLibrary(hInst);

	if (fRet == TRUE)
	{
		if (lstrlen(szFileName) > 0)
		{
			AutoSaveFile();

			if (g_pCardSet != NULL)
			{
				delete g_pCardSet;
				g_pCardSet = new CCardSet();
			}
			if (g_pTemplate != NULL)
			{
				delete g_pTemplate;
				g_pTemplate = new CTemplate();
			}

			OpenDataFile(szFileName);

			LPTSTR psz = _tcsrchr(szFileName, _T('\\'));
			if (psz) 
				*psz = NULL;
			m_strLastDir  = szFileName;
		}
	}
}

void CMainFrame::OpenDataFile(LPCTSTR szFileName)
{
	g_strCardFile = szFileName;
	AfxGetApp()->DoWaitCursor(1);
	if (CCardFile::LoadFile(g_strCardFile, g_pCardSet, g_pTemplate, g_pQuizSetting) == false)
	{
		CString strMsg;
		strMsg.LoadString(IDS_FILE_OPEN_FAILED);
		MessageBox(strMsg, AfxGetAppName(), MB_OK |  MB_ICONERROR);
	}
	AfxGetApp()->DoWaitCursor(-1);
	m_wndView.BuildFonts();
	m_wndView.ChangeMode(g_ProgramMode, true);
}

void CMainFrame::OnConvert() 
{
	TCHAR szFileName[MAX_PATH];
	memset(szFileName, 0, sizeof(TCHAR)* MAX_PATH);

	BOOL fRet;
	OPENFILENAME ofn;
	memset(&(ofn), 0, sizeof(ofn));

	ofn.lStructSize	= sizeof(ofn);
	ofn.hwndOwner   = GetSafeHwnd();
	ofn.lpstrFile   = szFileName;
	ofn.nMaxFile    = MAX_PATH;	
	ofn.lpstrTitle  = _T("ؽƮ  ..");
	ofn.lpstrFilter = _T("ؽƮ  (*.txt)\0*.txt\0  (*.*)\0*.*\0\0");
	ofn.Flags       = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	if (m_strLastDir.GetLength() >= 0)
		ofn.lpstrInitialDir = m_strLastDir;
	else
		ofn.lpstrInitialDir = NULL;

	BOOL (*gsGetOpenFileName)(OPENFILENAME*) = NULL;

	HINSTANCE hInst = LoadLibrary(_T("gsgetfile.dll"));
	if (hInst) 
	{
		(FARPROC&)gsGetOpenFileName = GetProcAddress(hInst, _T("gsGetOpenFileName"));
	}

	if (gsGetOpenFileName) 
		fRet = gsGetOpenFileName(&ofn);
	else 
		fRet = GetOpenFileName(&ofn);

	if (hInst) 
		FreeLibrary(hInst);

	if (fRet == TRUE)
	{
		if (lstrlen(szFileName) > 0)
		{
			AutoSaveFile();

			if (g_pCardSet != NULL)
			{
				delete g_pCardSet;
				g_pCardSet = new CCardSet();
			}
			if (g_pTemplate != NULL)
			{
				delete g_pTemplate;
				g_pTemplate = new CTemplate();
			}

			if (g_pQuizSetting != NULL)
			{
				delete g_pQuizSetting;
				g_pQuizSetting = new CQuizSetting();
			}

			g_strCardFile = szFileName;
			AfxGetApp()->DoWaitCursor(1);
			if (CCardFile::ImportTextFile(g_strCardFile, g_pCardSet) == false)
			{
				CString strMsg;
				strMsg.LoadString(IDS_FILE_OPEN_FAILED);
				MessageBox(strMsg, AfxGetAppName(), MB_OK |  MB_ICONERROR);
			}
			g_pCardSet->MoveToFirst();
			g_pQuizSetting->SetEndCardIndex( g_pCardSet->GetNumCards() -1 );
			AutoSaveFile();
			AfxGetApp()->DoWaitCursor(-1);

			LPTSTR psz = _tcsrchr(szFileName, _T('\\'));
			if (psz) 
				*psz = NULL;
			m_strLastDir  = szFileName;
			m_wndView.BuildFonts();

			m_wndView.ChangeMode(g_ProgramMode, true);
		}
	}

}




void CMainFrame::OnMemorizeMode() 
{
	m_wndView.ChangeMode(MEMORIZE_MODE);
}

void CMainFrame::OnStudyMode() 
{
	m_wndView.ChangeMode(STUDY_MODE);
}

void CMainFrame::OnQuizMode() 
{
	//m_wndView.SetupQuiz();
	//m_wndView.SendMessage(WM_COMMAND, MAKEWPARAM(0, ID_SETUP_QUIZ), (LPARAM)GetSafeHwnd());
	m_wndView.ChangeMode(QUIZ_MODE);
}

BOOL CMainFrame::PreTranslateMessage(MSG* pMsg) 
{
	switch(pMsg->message)
	{
		case WM_KEYDOWN:
		{
			if (g_pCardSet->GetNumCards() > 0)
			{
				if (g_ProgramMode == MEMORIZE_MODE) //ϱΰ 
				{
					switch(pMsg->wParam)
					{
						case VK_UP:
							m_wndView.AnswerOnCard(true);
							return TRUE;
						case VK_DOWN:
							m_wndView.AnswerOnCard(false);
							return TRUE;
						case VK_RIGHT:
							m_wndView.ShowAnswerCard();
							return TRUE;
					}
				}
				else if (g_ProgramMode == STUDY_MODE)
				{
					switch(pMsg->wParam)
					{
						case VK_UP:
						case VK_LEFT:
							m_wndView.MoveToPrevCard();
							return TRUE;

						case VK_DOWN:
						case VK_RIGHT:
							m_wndView.MoveToNextCard();
							return TRUE;
					}
				}
				else //QUIZ MODE
				{
					switch(pMsg->wParam)
					{
						case 0x31:
						case VK_NUMPAD1:
							m_wndView.AnswerOnQuiz(0);
							return TRUE;
						case 0x32:
						case VK_NUMPAD2:
							m_wndView.AnswerOnQuiz(1);
							return TRUE;
						case 0x33:
						case VK_NUMPAD3:
							m_wndView.AnswerOnQuiz(2);
							return TRUE;
						case 0x34:
						case VK_NUMPAD4:
							m_wndView.AnswerOnQuiz(3);
							return TRUE;
						case 0x35:
						case VK_NUMPAD5:
							m_wndView.AnswerOnQuiz(4);
							return TRUE;
						case 0x36:
						case VK_NUMPAD6:
							m_wndView.AnswerOnQuiz(5);
							return TRUE;
						case VK_RIGHT:
							m_wndView.MoveToNextCard();
							return TRUE;
					}
				}
			}
		}
	}
	return CFrameWnd::PreTranslateMessage(pMsg);
}

void CMainFrame::OnResetMemoryStatus() 
{
	CString strMsg;
	strMsg.LoadString(IDS_RESET_MEMORIZING);
	if (MessageBox(strMsg, AfxGetAppName(), MB_YESNO | MB_ICONQUESTION) == IDYES)
	{
		g_pCardSet->ResetMemorizing();
		m_wndView.InvalidateRect(NULL, TRUE);
	}		
}

void CMainFrame::OnClose() 
{
	m_wndView.SaveSetting();
	HKEY hKey;
	DWORD dwDisposition ;
	if (ERROR_SUCCESS == RegCreateKeyEx( HKEY_LOCAL_MACHINE, REG_PATH, 0 , 
		NULL, 0, 0, NULL, &hKey, &dwDisposition))
	{
		//ֱ 
		RegSetValueEx(hKey, REG_VALUE_LAST_PATH, 0, REG_SZ,
			(const BYTE *)((LPCTSTR)m_strLastDir), 
			sizeof(TCHAR) * ( m_strLastDir.GetLength() + 1) );
		RegCloseKey(hKey);
	}
	AutoSaveFile();
	CFrameWnd::OnClose();
}



void CMainFrame::OnImportTemplete() 
{
	TCHAR szFileName[MAX_PATH];
	memset(szFileName, 0, sizeof(TCHAR)* MAX_PATH);

	BOOL fRet;
	OPENFILENAME ofn;
	memset(&(ofn), 0, sizeof(ofn));

	ofn.lStructSize	= sizeof(ofn);
	ofn.hwndOwner   = GetSafeHwnd();
	ofn.lpstrFile   = szFileName;
	ofn.nMaxFile    = MAX_PATH;	
	ofn.lpstrTitle  = _T("ø  ..");
	ofn.lpstrFilter = _T("ø  (*.mkt)\0*.mkt\0  (*.*)\0*.*\0\0");
	ofn.Flags       = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	if (m_strLastDir.GetLength() >= 0)
		ofn.lpstrInitialDir = m_strLastDir;
	else
		ofn.lpstrInitialDir = NULL;

	BOOL (*gsGetOpenFileName)(OPENFILENAME*) = NULL;

	HINSTANCE hInst = LoadLibrary(_T("gsgetfile.dll"));
	if (hInst) 
	{
		(FARPROC&)gsGetOpenFileName = GetProcAddress(hInst, _T("gsGetOpenFileName"));
	}

	if (gsGetOpenFileName) 
		fRet = gsGetOpenFileName(&ofn);
	else 
		fRet = GetOpenFileName(&ofn);


	if (hInst) 
		FreeLibrary(hInst);

	if (fRet == TRUE)
	{
		if (lstrlen(szFileName) > 0)
		{
			g_pTemplate->ImportFromFile(szFileName);
			LPTSTR psz = _tcsrchr(szFileName, _T('\\'));
			if (psz) 
				*psz = NULL;
			m_strLastDir  = szFileName;
			m_wndView.BuildFonts();
			m_wndView.InvalidateRect(NULL, TRUE);
		}
	}
}

void CMainFrame::OnExportTemplete() 
{
	TCHAR szFileName[MAX_PATH];
	memset(szFileName, 0, sizeof(TCHAR)* MAX_PATH);

	BOOL fRet;
	OPENFILENAME ofn;
	memset(&(ofn), 0, sizeof(ofn));

	ofn.lStructSize	= sizeof(ofn);
	ofn.hwndOwner   = GetSafeHwnd();
	ofn.lpstrFile   = szFileName;
	ofn.nMaxFile    = MAX_PATH;	
	ofn.lpstrTitle  = _T("ø  ϱ..");
	ofn.lpstrFilter = _T("ø  (*.mkt)\0*.mkt\0  (*.*)\0*.*\0\0");
	ofn.Flags       = OFN_EXPLORER | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
	if (m_strLastDir.GetLength() >= 0)
		ofn.lpstrInitialDir = m_strLastDir;
	else
		ofn.lpstrInitialDir = NULL;

	BOOL (*gsGetSaveFileName)(OPENFILENAME*) = NULL;

	HINSTANCE hInst = LoadLibrary(_T("gsgetfile.dll"));
	if (hInst) 
	{
		(FARPROC&)gsGetSaveFileName = GetProcAddress(hInst, _T("gsGetSaveFileName"));
	}

	if (gsGetSaveFileName) 
		fRet = gsGetSaveFileName(&ofn);
	else 
		fRet = GetSaveFileName(&ofn);


	if (hInst) 
		FreeLibrary(hInst);

	if (fRet == TRUE)
	{
		if (lstrlen(szFileName) > 0)
		{
			g_pTemplate->ExportToFile(szFileName);
			LPTSTR psz = _tcsrchr(szFileName, _T('\\'));
			if (psz) 
				*psz = NULL;
			m_strLastDir  = szFileName;
		}
	}
}

void CMainFrame::OnDestroy() 
{
	CFrameWnd::OnDestroy();
	
	//m_wndView.SaveSetting();
	//AutoSaveFile();
}

void CMainFrame::OnFileExport() 
{
	bool bUnicode = false;
	//ڵ ؾ  ˻Ѵ.
	if (g_pTemplate->IsMixedCharSet() == true)
	{
		CString strMsg;
		strMsg.LoadString(IDS_SAVE_UNICODE_TEXT);
		if (MessageBox(strMsg, AfxGetAppName(), MB_YESNO | MB_ICONQUESTION) == IDYES)
			bUnicode = true;
	}

	int nIndex = g_strCardFile.ReverseFind(_T('.'));
	TCHAR szFileName[MAX_PATH];
	lstrcpy(szFileName, g_strCardFile.Left(nIndex));
	lstrcat(szFileName, _T(".txt"));


	BOOL fRet;
	OPENFILENAME ofn;
	memset(&(ofn), 0, sizeof(ofn));

	ofn.lStructSize	= sizeof(ofn);
	ofn.hwndOwner   = GetSafeHwnd();
	ofn.lpstrFile   = szFileName;
	ofn.nMaxFile    = MAX_PATH;	
	ofn.lpstrTitle  = _T("ؽƮ Ϸ ϱ..");
	ofn.lpstrFilter = _T("ؽƮ  (*.txt)\0*.txt\0  (*.*)\0*.*\0\0");
	ofn.Flags       = OFN_EXPLORER | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT;
	if (m_strLastDir.GetLength() >= 0)
		ofn.lpstrInitialDir = m_strLastDir;
	else
		ofn.lpstrInitialDir = NULL;

	BOOL (*gsGetOpenFileName)(OPENFILENAME*) = NULL;

	HINSTANCE hInst = LoadLibrary(_T("gsgetfile.dll"));
	if (hInst) 
	{
		(FARPROC&)gsGetOpenFileName = GetProcAddress(hInst, _T("gsGetOpenFileName"));
	}

	if (gsGetOpenFileName) 
		fRet = gsGetOpenFileName(&ofn);
	else 
		fRet = GetOpenFileName(&ofn);

	if (hInst) 
		FreeLibrary(hInst);

	if (fRet == TRUE)
	{
		if (lstrlen(szFileName) > 0)
		{
			CCardFile::ExportToTextFile(szFileName, g_pCardSet, bUnicode);
			LPTSTR psz = _tcsrchr(szFileName, _T('\\'));
			if (psz) 
				*psz = NULL;
			m_strLastDir  = szFileName;
		}
	}
}


void CMainFrame::OnConvertAdd() 
{
	TCHAR szFileName[MAX_PATH];
	memset(szFileName, 0, sizeof(TCHAR)* MAX_PATH);

	BOOL fRet;
	OPENFILENAME ofn;
	memset(&(ofn), 0, sizeof(ofn));

	ofn.lStructSize	= sizeof(ofn);
	ofn.hwndOwner   = GetSafeHwnd();
	ofn.lpstrFile   = szFileName;
	ofn.nMaxFile    = MAX_PATH;	
	ofn.lpstrTitle  = _T("ؽƮ  ..");
	ofn.lpstrFilter = _T("ؽƮ  (*.txt)\0*.txt\0  (*.*)\0*.*\0\0");
	ofn.Flags       = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	if (m_strLastDir.GetLength() >= 0)
		ofn.lpstrInitialDir = m_strLastDir;
	else
		ofn.lpstrInitialDir = NULL;

	BOOL (*gsGetOpenFileName)(OPENFILENAME*) = NULL;

	HINSTANCE hInst = LoadLibrary(_T("gsgetfile.dll"));
	if (hInst) 
	{
		(FARPROC&)gsGetOpenFileName = GetProcAddress(hInst, _T("gsGetOpenFileName"));
	}

	if (gsGetOpenFileName) 
		fRet = gsGetOpenFileName(&ofn);
	else 
		fRet = GetOpenFileName(&ofn);

	if (hInst) 
		FreeLibrary(hInst);

	if (fRet == TRUE)
	{
		if (lstrlen(szFileName) > 0)
		{
			CString strCardFile = szFileName;
			AfxGetApp()->DoWaitCursor(1);
			if (CCardFile::ImportTextFile(strCardFile, g_pCardSet) == false)
			{
				CString strMsg;
				strMsg.LoadString(IDS_FILE_OPEN_FAILED);
				MessageBox(strMsg, AfxGetAppName(), MB_OK |  MB_ICONERROR);
			}
			g_pCardSet->MoveToFirst();
			g_pQuizSetting->SetEndCardIndex( g_pCardSet->GetNumCards() -1 );
			AutoSaveFile();
			AfxGetApp()->DoWaitCursor(-1);
			LPTSTR psz = _tcsrchr(szFileName, _T('\\'));
			if (psz) 
				*psz = NULL;
			m_strLastDir  = szFileName;

			m_wndView.ChangeMode(g_ProgramMode, true);
		}
	}
}
