// OptionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MemoKing.h"
#include "OptionDlg.h"
#include "Utils.h"
#include "define.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COptionDlg dialog


COptionDlg::COptionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COptionDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COptionDlg)
	m_bSeqMemoMode = FALSE;
	m_bWordwrap = FALSE;
	m_dwButtonSize = 0;
	m_bShowStatusIcon = FALSE;
	m_nPenWidth = 0;
	//}}AFX_DATA_INIT
}


void COptionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionDlg)
	DDX_Check(pDX, IDC_SEQ_MEMORIZE_MODE, m_bSeqMemoMode);
	DDX_Check(pDX, IDC_WORDWRAP, m_bWordwrap);
	DDX_Text(pDX, IDC_BUTTON_SIZE, m_dwButtonSize);
	DDX_Check(pDX, IDC_SHOW_STATUS_ICON, m_bShowStatusIcon);
	DDX_Text(pDX, IDC_PEN_WIDTH, m_nPenWidth);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptionDlg, CDialog)
	//{{AFX_MSG_MAP(COptionDlg)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_CHANGE_BACKGROUND, OnChangeBackground)
	ON_BN_CLICKED(IDC_CHANGE_PEN_COLOR, OnChangePenColor)
	ON_BN_CLICKED(IDC_SMALL_BUTTON, OnSmallButton)
	ON_BN_CLICKED(IDC_MIDDLE_BUTTON, OnMiddleButton)
	ON_BN_CLICKED(IDC_BIG_BUTTON, OnBigButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionDlg message handlers

void COptionDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	CString strMsg;
	strMsg.LoadString(IDS_OPTIONS);
	::PaintHeader(dc, strMsg);	
	
	CRect rcWnd;
	GetWindowRect(rcWnd);
	CWnd* pwndBtn = GetDlgItem(IDC_CHANGE_BACKGROUND);
	CRect rcBtn;
	pwndBtn->GetWindowRect(rcBtn);
	rcBtn.OffsetRect(0, -rcWnd.top);

	CRect rcColor;
	rcColor.top = rcBtn.top;
	rcColor.bottom = rcBtn.bottom;
	rcColor.left = rcBtn.right + 5;
	rcColor.right = rcColor.left + 50;
	
	CBrush brBack(m_rgbBack);
	CPen penBorder(PS_SOLID, 1, RGB(128, 128, 128));
	HFONT hFontSys = (HFONT)GetStockObject(SYSTEM_FONT);
	CFont* pfontSys = CFont::FromHandle(hFontSys);
	
	CPen* pOldPen = dc.SelectObject(&penBorder);
	CBrush* pOldBrush = dc.SelectObject(&brBack);
	CFont* pOldFont = dc.SelectObject(pfontSys);
	int nOldBkMode = dc.SetBkMode(TRANSPARENT);
	
	dc.Rectangle(rcColor);
	
	dc.DrawText(_T("Sample"), -1, rcColor, DT_CENTER | DT_VCENTER | DT_SINGLELINE);

	pwndBtn = GetDlgItem(IDC_CHANGE_PEN_COLOR);
	pwndBtn->GetWindowRect(rcBtn);
	rcBtn.OffsetRect(0, -rcWnd.top);
	rcColor.top = rcBtn.top;
	rcColor.bottom = rcBtn.bottom;
	rcColor.left = rcBtn.right + 5;
	rcColor.right = rcColor.left + 50;

	CBrush brPen(m_rgbPen);
	dc.SelectObject(&brPen);
	dc.Rectangle(rcColor);

	dc.SetBkMode(nOldBkMode);
	dc.SelectObject(pOldPen);
	dc.SelectObject(pOldBrush);
	dc.SelectObject(pOldFont);
	// Do not call CDialog::OnPaint() for painting messages
}

void COptionDlg::OnChangeBackground() 
{
	CHOOSECOLOR cc;                 // common dialog box structure 
	static COLORREF acrCustClr[16]; // array of custom colors 
	
	// Initialize CHOOSECOLOR 
	ZeroMemory(&cc, sizeof(cc));
	cc.lStructSize = sizeof(cc);
	cc.hwndOwner = GetSafeHwnd();
	cc.lpCustColors = (LPDWORD) acrCustClr;
	cc.rgbResult = m_rgbBack;
	cc.Flags = CC_SOLIDCOLOR | CC_RGBINIT;

	if (ChooseColor(&cc)==TRUE) 
	{
		m_rgbBack = cc.rgbResult ;
		InvalidateRect(NULL, TRUE);
	}
}

void COptionDlg::OnChangePenColor() 
{
	CHOOSECOLOR cc;                 // common dialog box structure 
	static COLORREF acrCustClr[16]; // array of custom colors 
	
	// Initialize CHOOSECOLOR 
	ZeroMemory(&cc, sizeof(cc));
	cc.lStructSize = sizeof(cc);
	cc.hwndOwner = GetSafeHwnd();
	cc.lpCustColors = (LPDWORD) acrCustClr;
	cc.rgbResult = m_rgbBack;
	cc.Flags = CC_SOLIDCOLOR | CC_RGBINIT;

	if (ChooseColor(&cc)==TRUE) 
	{
		m_rgbPen = cc.rgbResult ;
		InvalidateRect(NULL, TRUE);
	}
}

BOOL COptionDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	SendDlgItemMessage(IDC_BUTTON_SIZE_SPIN,UDM_SETRANGE,0,MAKELONG(100, 16));
	SendDlgItemMessage(IDC_PEN_WIDTH_SPIN,UDM_SETRANGE,0,MAKELONG(4, 1));
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void COptionDlg::OnOK() 
{
	UpdateData(TRUE);
	if (m_dwButtonSize < 16 || m_dwButtonSize > 100)
	{	
		CString strMsg;
		strMsg.LoadString(IDS_INVALID_BUTTON_SIZE);
		MessageBox(strMsg, AfxGetAppName(), MB_OK | MB_ICONWARNING);
		return;
	}
	if (m_nPenWidth < 1 || m_nPenWidth > 4)
	{
		CString strMsg;
		strMsg.LoadString(IDS_INVALUD_PEN_WIDTH);
		MessageBox(strMsg, AfxGetAppName(), MB_OK | MB_ICONWARNING);
	}
	
	CDialog::OnOK();
}

void COptionDlg::OnSmallButton() 
{
	m_dwButtonSize = BUTTON_HEIGHT;
	UpdateData(FALSE);
}

void COptionDlg::OnMiddleButton() 
{
	m_dwButtonSize = BUTTON_HEIGHT * 2;
	UpdateData(FALSE);
}

void COptionDlg::OnBigButton() 
{
	m_dwButtonSize = BUTTON_HEIGHT * 3;
	UpdateData(FALSE);	
}
