// Quiz.cpp: implementation of the CQuiz class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MemoKing.h"
#include "Define.h"
#include "Quiz.h"
#include "Card.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

CQuizSetting::CQuizSetting()
{
	m_uiNumTotalQuiz = 10;         //ü  
	m_uiQuestionIndex = 0; // Index
	m_uiAnswerIndex = 1;   // Index

	m_uiFontSize = 10; 
	m_uiNumExample = 4; 

	m_bInternalExam = FALSE;
	m_bQuizResultSync = FALSE;
	m_bMemorizedCardOnly = FALSE;
	m_bNotMemorizedCardOnly = FALSE;
	m_bSelectedCardOnly = FALSE;
	m_uiStartCardIndex = 0;
	m_uiEndCardIndex = 0;

	m_bModified = false;
}

bool CQuizSetting::SaveToFile(CFile* pFile) const
{
	ASSERT(pFile != NULL);

	pFile->Write((void*)&m_uiNumTotalQuiz, sizeof(UINT));
	pFile->Write((void*)&m_uiQuestionIndex, sizeof(UINT));
	pFile->Write((void*)&m_uiAnswerIndex, sizeof(UINT));

	//Ver 4 PLUS
	pFile->Write((void*)&m_uiFontSize, sizeof(UINT));
	pFile->Write((void*)&m_uiNumExample, sizeof(UINT));
	pFile->Write((void*)&m_bInternalExam, sizeof(BOOL));
	pFile->Write((void*)&m_bQuizResultSync, sizeof(BOOL));
	pFile->Write((void*)&m_bMemorizedCardOnly, sizeof(BOOL));
	pFile->Write((void*)&m_bNotMemorizedCardOnly, sizeof(BOOL));
	pFile->Write((void*)&m_bSelectedCardOnly, sizeof(BOOL));
	pFile->Write((void*)&m_uiStartCardIndex, sizeof(UINT));
	pFile->Write((void*)&m_uiEndCardIndex, sizeof(UINT));

	return true;
}

bool CQuizSetting::SaveToFile(HANDLE hFile) const
{
	ASSERT(hFile != NULL);

	QUIZSETTING qs;

	qs.uiNumTotalQuiz = m_uiNumTotalQuiz;
	qs.uiQuestionIndex = m_uiQuestionIndex;
	qs.uiAnswerIndex = m_uiAnswerIndex;
	qs.uiNumTotalQuiz = m_uiFontSize;
	qs.uiNumExample = m_uiNumExample;
	qs.bInternalExam = m_bInternalExam;
	qs.bQuizResultSync = m_bQuizResultSync;
	qs.bMemorizedCardOnly = m_bMemorizedCardOnly;
	qs.bNotMemorizedCardOnly = m_bNotMemorizedCardOnly;
	qs.bSelectedCardOnly = m_bSelectedCardOnly;
	qs.uiStartCardIndex = m_uiStartCardIndex;
	qs.uiEndCardIndex = m_uiEndCardIndex;

	DWORD dwWritten;
	WriteFile(hFile, (void*)&qs, sizeof(QUIZSETTING), &dwWritten, NULL);

	return true;
}

bool CQuizSetting::LoadFromFile(CFile* pFile, WORD wVersion, DWORD dwNumCards)
{
	ASSERT(pFile != NULL);

	DWORD dwRead;
	dwRead = pFile->Read((void*)&m_uiNumTotalQuiz, sizeof(UINT));
	if (dwRead != sizeof(UINT))
		return false;
	dwRead = pFile->Read((void*)&m_uiQuestionIndex, sizeof(UINT));
	if (dwRead != sizeof(UINT))
		return false;
	dwRead = pFile->Read((void*)&m_uiAnswerIndex, sizeof(UINT));
	if (dwRead != sizeof(UINT))
		return false;

	if (wVersion < 0x0004) // Ver3     
	{
		m_uiStartCardIndex = 0;
		m_uiEndCardIndex = dwNumCards -1;

		m_uiFontSize = 10; 
		m_uiNumExample = 4; 

		m_bInternalExam = FALSE;
		m_bQuizResultSync = FALSE;
		m_bMemorizedCardOnly = FALSE;
		m_bNotMemorizedCardOnly = FALSE;
		m_bSelectedCardOnly = FALSE;

		m_bModified = false;
	}
	else
	{
		dwRead = pFile->Read((void*)&m_uiFontSize, sizeof(UINT));
		if (dwRead != sizeof(UINT))
			return false;

		dwRead = pFile->Read((void*)&m_uiNumExample, sizeof(UINT));
		if (dwRead != sizeof(UINT))
			return false;

		dwRead = pFile->Read((void*)&m_bInternalExam, sizeof(BOOL));
		if (dwRead != sizeof(BOOL))
			return false;

		if( wVersion < 0x0005) // Ver 4   
			m_bQuizResultSync = FALSE;
		else {
			dwRead = pFile->Read((void*)&m_bQuizResultSync, sizeof(BOOL));
			if (dwRead != sizeof(BOOL))
				return false;
		}

		dwRead = pFile->Read((void*)&m_bMemorizedCardOnly, sizeof(BOOL));
		if (dwRead != sizeof(BOOL))
			return false;

		if( wVersion < 0x0005) // Ver 4   
			m_bNotMemorizedCardOnly = FALSE;
		else {
			dwRead = pFile->Read((void*)&m_bNotMemorizedCardOnly, sizeof(BOOL));
			if (dwRead != sizeof(BOOL))
				return false;
		}

		dwRead = pFile->Read((void*)&m_bSelectedCardOnly, sizeof(BOOL));
		if (dwRead != sizeof(BOOL))
			return false;

		dwRead = pFile->Read((void*)&m_uiStartCardIndex, sizeof(UINT));
		if (dwRead != sizeof(UINT))
			return false;

		dwRead = pFile->Read((void*)&m_uiEndCardIndex, sizeof(UINT));
		if (dwRead != sizeof(UINT))
			return false;
	}
	return true;
}

bool CQuizSetting::CheckSetting(CCardSet* pCardSet) const
{
	UINT uiSelectCard;

	//     ٸ  Ű.

	//ϱ ī常  ϴ  
	if (m_bMemorizedCardOnly == TRUE)
	{
		uiSelectCard = pCardSet->GetNumMemorizedCards();
		//ϱ ī      
//		if (uiSelectCard < m_uiNumTotalQuiz)
//			SetTotalQuiz( uiSelectCard );
//			//return false;
//			// [ȯ] ī  ڸ  .
		
	}
	else if (m_bNotMemorizedCardOnly == TRUE)
	{
		uiSelectCard = pCardSet->GetNumNotMemorizedCards();
//		//ϱ  ī      
//		if (uiSelectCard < m_uiNumTotalQuiz)
//			m_uiNumTotalQuiz = uiSelectCard;
//			//return false;
//			// [ȯ] ī  ڸ  .
	}
	else if (m_bSelectedCardOnly == TRUE)
	{
//		// ī 
		uiSelectCard = m_uiEndCardIndex - m_uiStartCardIndex + 1;
//		if (uiSelectCard < m_uiNumTotalQuiz)
//			m_uiNumTotalQuiz = uiSelectCard;
//			//return false;
//			// [ȯ] ī  ڸ  .
	}
	else 
	{
//		//ü ī
		uiSelectCard = m_uiNumTotalQuiz;
//		if ( uiSelectCard > pCardSet->GetNumCards())
//			m_uiNumTotalQuiz = uiSelectCard;
//			//return false;
//			// [ȯ] ī  ڸ  .
	}

	//ī  ּ ʿ example   츦 ˻
	if (uiSelectCard < m_uiNumExample )
		return false;

	return true;
}


CQuiz::CQuiz(CCard* pQuizCard, CCardSet* pCardSet, UINT uiNumExam)
{
	ASSERT(pQuizCard != NULL);
	ASSERT(pCardSet != NULL);
	ASSERT(uiNumExam >= NUM_MIN_EXAMPLE && uiNumExam <= NUM_MAX_EXAMPLE);
	ASSERT(pCardSet->GetNumCards() >= uiNumExam);

	m_pQuizCard = pQuizCard;
	if (m_arCard.GetSize() != 0)
		m_arCard.RemoveAll();

	m_arCard.SetSize(uiNumExam);
	m_uiWrightAnswer = rand() % uiNumExam;

	CARD_LIST lstExamCard;

	CCard* pCard;
	for (UINT i = 0; i < uiNumExam; i++)
	{
		if ( i == m_uiWrightAnswer ) //̸ 
		{
			pCard = pQuizCard;
		}
		else
		{
			bool bDuplicate;
			do
			{
				pCard = pCardSet->GetRandomCard();
				bDuplicate = false;
				if (pCard == pQuizCard) //  ī ȵ
					bDuplicate = true;
				else
				{
					CCard* pInseredCard;
					//  ͵鿡 ߺ  ִ Ȯ 
					for (UINT j = 0; j < i; j++) 
					{
						pInseredCard = m_arCard.GetAt(j);
						if (pCard == pInseredCard)
							bDuplicate = true;
					}
				}
			}
			while ( bDuplicate == true );
		}
		m_arCard.SetAt(i, pCard);
	}
}

CQuiz::CQuiz(CCard* pQuizCard, UINT uiNumExam, UINT uiQuestion, UINT uiAnswer)
{
	ASSERT(pQuizCard != NULL);
	ASSERT(uiNumExam >= NUM_MIN_EXAMPLE && uiNumExam <= NUM_MAX_EXAMPLE);

	m_pQuizCard = pQuizCard;
	m_arExample.SetSize(uiNumExam);
	m_arExampleWordIndex.SetSize(uiNumExam);		// [ȯ]  ܾ ̾ش.

	//ī  ߿      Ѵ.
	for (UINT i = 0; i < uiNumExam; i++)
	{
		bool bValidIndex;
		UINT uiItemIndex;
		do
		{
			bValidIndex = true;
			uiItemIndex = rand() % NUM_MAX_EXAMPLE;

			if (uiItemIndex == uiQuestion) //  ȵ
				bValidIndex = false;
			else
			{
				//  ͵鿡 ߺ  ִ Ȯ 
				for (UINT j = 0; j < i; j++) 
				{
					if (m_arExample[j] == uiItemIndex)
						bValidIndex = false;
				}
			}

			LPCTSTR szWord = pQuizCard->GetWord(uiItemIndex);
			if (szWord == NULL)
				bValidIndex = false;
			else
			{
				if (lstrlen(szWord) == 0)
					bValidIndex = false;
			}
		}
		while ( bValidIndex == false );
		
		m_arExample.SetAt(i, uiItemIndex);
		m_arExampleWordIndex.SetAt(i, rand() % pQuizCard->GetParsedWordCount(uiItemIndex) );	// [ȯ]  ܾ ϳ set  ش.

		if (uiItemIndex == uiAnswer)
			m_uiWrightAnswer = i;
	}
}

CCard* CQuiz::GetExampleCard(int nIndex) const
{
	ASSERT(nIndex < m_arCard.GetSize());

	return m_arCard[nIndex];
}

LPCTSTR CQuiz::GetExampleWord(int nIndex) const
{
	ASSERT(nIndex < m_arExample.GetSize());
	
	return m_pQuizCard->GetWord(m_arExample[nIndex]);
}

/********* [ȯ] GetExampleParsedWord()  *******/
CString CQuiz::GetExampleParsedWord(int nIndex) const
{
	int nParseIndex;
	ASSERT(nIndex < m_arExample.GetSize());

	// nParseIndex 迭 ̾ƿ.
	nParseIndex = m_arExampleWordIndex[nIndex];

	// Ʈ ȯ
	return m_pQuizCard->GetParsedWord(m_arExample[nIndex], nParseIndex);

}
/******** [ȯ] GetExampleParsedWord()  *******/

/********* [ȯ] GetExampleParsedWordIndex()  *******/
int CQuiz::GetExampleParsedWordIndex(int nIndex) const
{
	ASSERT(nIndex < m_arExample.GetSize());

	return m_arExampleWordIndex[nIndex];
}
/********* [ȯ] GetExampleParsedWordIndex()  *******/


CQuizList::CQuizList()
{

}

CQuizList::~CQuizList()
{
	Clear();	
}

void CQuizList::Clear()
{
	m_nQuizIndex = 0;
	m_nNumHit = 0;
	m_nNumAnswered = 0;

	CQuiz* pQuiz;
	for (int i=0; i < m_arQuiz.GetSize(); i++)
	{
		pQuiz = m_arQuiz.ElementAt(i);
		delete pQuiz;
	}
	m_arQuiz.RemoveAll();
}

void CQuizList::GenerateList(CCardSet* pCardSet, CQuizSetting* pQuizSetting)
{
	Clear();
	// List Copy ϳ .
	CARD_LIST lstCardTemp; 

	//Copy the master list
	CCard* pCard;
	if (pQuizSetting->IsSelectedCardOnly() == TRUE)
	{
		for (UINT i = pQuizSetting->GetStartCardIndex(); i < pQuizSetting->GetEndCardIndex() + 1; i++)
		{
			pCard = pCardSet->GetCardFromIndex(i);
			lstCardTemp.AddTail(pCard);
		}
	}
	else
	{
		for (UINT i = 0; i < pCardSet->GetNumCards(); i++)
		{
			pCard = pCardSet->GetCardFromIndex(i);
			lstCardTemp.AddTail(pCard);
		}
	}

	// ڵ    
	UINT uiSelectCard;

	if (pQuizSetting->IsMemorizedCardOnly())
	{
		uiSelectCard = pCardSet->GetNumMemorizedCards();
		if ( uiSelectCard < pQuizSetting->GetTotalQuiz() )
			pQuizSetting->SetTotalQuiz( uiSelectCard );
	}
	else if (pQuizSetting->IsNotMemorizedCardOnly())
	{
		uiSelectCard = pCardSet->GetNumNotMemorizedCards();
		if ( uiSelectCard < pQuizSetting->GetTotalQuiz() )
			pQuizSetting->SetTotalQuiz( uiSelectCard );
	}
	else if (pQuizSetting->IsSelectedCardOnly())
	{
		uiSelectCard = pQuizSetting->GetEndCardIndex() - pQuizSetting->GetStartCardIndex() + 1;
		if ( uiSelectCard < pQuizSetting->GetTotalQuiz() )
			pQuizSetting->SetTotalQuiz( uiSelectCard );
	}
	else 
	{
		uiSelectCard = pCardSet->GetNumCards();
		if ( uiSelectCard < pQuizSetting->GetTotalQuiz() )
			pQuizSetting->SetTotalQuiz( uiSelectCard );
	}

	// ڵ    

	//Make the random quiz list
	int nIndex;
	POSITION posCard;
	CQuiz* pQuiz;

	UINT uiQuizCount = 0;
	BOOL bIsOK;
	while(uiQuizCount < pQuizSetting->GetTotalQuiz())
	{
		nIndex = rand() % lstCardTemp.GetCount();
		posCard = lstCardTemp.FindIndex(nIndex);
		pCard = (CCard*)lstCardTemp.GetAt(posCard);

		/* [ȯ] Memorized Card ó ⼭  ش */
		if (pQuizSetting->IsMemorizedCardOnly())
			bIsOK = pCard->IsMemorized();
		else if (pQuizSetting->IsNotMemorizedCardOnly())
			bIsOK = !(pCard->IsMemorized());
		else
			bIsOK = TRUE;

		if (bIsOK == TRUE)
		{
			uiQuizCount++;
			if (pQuizSetting->IsInternalExamMode() == TRUE)
				pQuiz = new CQuiz(pCard, pQuizSetting->GetNumExample(),
					pQuizSetting->GetQuestionIndex(),
					pQuizSetting->GetAnswerIndex());
			else
				pQuiz = new CQuiz(pCard, pCardSet, pQuizSetting->GetNumExample());

			m_arQuiz.Add(pQuiz);
			lstCardTemp.RemoveAt(posCard);
		}
	}
}

bool CQuizList::MoveToNext()
{
	if (m_nQuizIndex + 1 < m_arQuiz.GetSize())
	{
		m_nQuizIndex++;
		return true;
	}
	else
		return false;
}

// 
bool CQuizList::AnswerOnQuiz(UINT uiIndex)
{
	m_nNumAnswered++;
	if (m_arQuiz[m_nQuizIndex]->Answer(uiIndex) == true)
	{
		m_nNumHit++;
		return true;
	}
	else
		return false;
}