// Quiz.h: interface for the CQuiz class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_QUIZ_H__538D0B20_F5E4_42D2_9CEF_24DCD1B03BEA__INCLUDED_)
#define AFX_QUIZ_H__538D0B20_F5E4_42D2_9CEF_24DCD1B03BEA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CCardSet;
class CCard;

typedef CArray <CCard*, CCard*> CARD_ARRAY;

typedef struct _QUIZSETTING
{
	UINT uiNumTotalQuiz;
	UINT uiQuestionIndex;
	UINT uiAnswerIndex;
	UINT uiFontSize;
	UINT uiNumExample;
	BOOL bInternalExam;
	BOOL bQuizResultSync;
	BOOL bMemorizedCardOnly;
	BOOL bNotMemorizedCardOnly;
	BOOL bSelectedCardOnly;
	UINT uiStartCardIndex;
	UINT uiEndCardIndex;
} QUIZSETTING;

class CQuizSetting
{
private:
	// 
	UINT m_uiNumTotalQuiz;    //ü  
	UINT m_uiQuestionIndex; // Index
	UINT m_uiAnswerIndex;   // Index

	UINT m_uiFontSize; // Ʈ ũ
	UINT m_uiNumExample; //  

	BOOL m_bInternalExam;
	BOOL m_bQuizResultSync;
	BOOL m_bMemorizedCardOnly;
	BOOL m_bNotMemorizedCardOnly;
	BOOL m_bSelectedCardOnly;
	BOOL m_bIsQuizResultSync;		// [ȯ] word quiz 
	UINT m_uiStartCardIndex;
	UINT m_uiEndCardIndex;

	bool m_bModified;
public:
	CQuizSetting();
	bool IsModified() const { return m_bModified; }
	bool SaveToFile(CFile* pFile) const;
	bool SaveToFile(HANDLE hFile) const;
	bool LoadFromFile(CFile* pFile, WORD wVersion, DWORD dwNumCards);

	UINT GetNumExample() const { return m_uiNumExample; }

	UINT GetQuestionIndex() const { return m_uiQuestionIndex; }
	UINT GetAnswerIndex() const { return m_uiAnswerIndex; }

	bool CheckSetting(CCardSet* pCardSet) const;

	UINT GetFontSize() const { return m_uiFontSize; }

	UINT GetTotalQuiz() const { return m_uiNumTotalQuiz; }
	void SetTotalQuiz(UINT uiNumTotalQuiz)
	{
		if (m_uiNumTotalQuiz != uiNumTotalQuiz)
		{
			m_uiNumTotalQuiz = uiNumTotalQuiz;
			m_bModified = true;
		}
	}

	void SetQuestionIndex( UINT uiQuestionIndex )
	{
		if (m_uiQuestionIndex != uiQuestionIndex)
		{
			m_uiQuestionIndex = uiQuestionIndex;
			m_bModified = true;
		}
	}

	void SetAnswerIndex( UINT uiAnswerIndex)
	{
		if (m_uiAnswerIndex != uiAnswerIndex)
		{
			m_uiAnswerIndex = uiAnswerIndex;
			m_bModified = true;
		}
	}


	void SetFontSize(UINT uiFontSize)
	{
		if (m_uiFontSize != uiFontSize)
		{
			m_uiFontSize = uiFontSize;
			m_bModified = true;
		}
	}

	void SetNumExample(UINT uiNumExample)
	{
		if (m_uiNumExample != uiNumExample)
		{
			m_uiNumExample = uiNumExample;
			m_bModified = true;
		}
	}

	BOOL IsInternalExamMode() const { return m_bInternalExam; }
	void SetInternalExamMode(BOOL bInternalExam)
	{
		if (m_bInternalExam != bInternalExam)
		{
			m_bInternalExam = bInternalExam;
			m_bModified = true;
		}
	}

	BOOL IsQuizResultSync() const { return m_bQuizResultSync; }
	void SetQuizResultSync(BOOL bQuizResultSync)
	{
		if (m_bQuizResultSync != bQuizResultSync)
		{
			m_bQuizResultSync = bQuizResultSync;
			m_bModified = true;
		}
	}


	BOOL IsMemorizedCardOnly() const { return m_bMemorizedCardOnly; }
	void SetMemorizedCardOnly(BOOL bMemorizedCardOnly)
	{
		if (m_bMemorizedCardOnly != bMemorizedCardOnly)
		{
			m_bMemorizedCardOnly = bMemorizedCardOnly;
			m_bModified = true;
		}
	}

	BOOL IsNotMemorizedCardOnly() const { return m_bNotMemorizedCardOnly; }
	void SetNotMemorizedCardOnly(BOOL bNotMemorizedCardOnly)
	{
		if (m_bNotMemorizedCardOnly != bNotMemorizedCardOnly)
		{
			m_bNotMemorizedCardOnly = bNotMemorizedCardOnly;
			m_bModified = true;
		}
	}

	BOOL IsSelectedCardOnly() const { return m_bSelectedCardOnly; }
	void SetSelectedCardOnly(BOOL bSelectedCardOnly)
	{
		if (m_bSelectedCardOnly != bSelectedCardOnly)
		{
			m_bSelectedCardOnly = bSelectedCardOnly;
			m_bModified = true;
		}
	}

	UINT GetStartCardIndex() const { return m_uiStartCardIndex; }
	void SetStartCardIndex(UINT uiStartCardIndex)
	{
		if (m_uiStartCardIndex != uiStartCardIndex)
		{
			m_uiStartCardIndex = uiStartCardIndex;
			m_bModified = true;
		}
	}

	UINT GetEndCardIndex() const { return m_uiEndCardIndex; }
	void SetEndCardIndex(UINT uiEndCardIndex)
	{
		if (m_uiEndCardIndex != uiEndCardIndex)
		{
			m_uiEndCardIndex = uiEndCardIndex;
			m_bModified = true;
		}
	}
};

typedef CArray <UINT, UINT> UINT_ARRAY;

class CQuiz
{
	friend class CQuizList;
protected:
	CCard* m_pQuizCard;
	CARD_ARRAY m_arCard; //ī 
	UINT_ARRAY m_arExample; //  
	UINT_ARRAY m_arExampleWordIndex; // [ȯ]     ° ܾ ϴ 

	UINT m_uiWrightAnswer; // Index
	bool m_bCorrect;

	bool Answer(UINT uiIndex) 
	{
		m_bCorrect = (m_uiWrightAnswer == uiIndex);
		return m_bCorrect;
	}

	CQuiz(CCard* pQuizCard, CCardSet* pCardSet, UINT uiNumExample);
	CQuiz(CCard* pQuizCard, UINT uiNumExam, UINT uiQuestion, UINT uiAnswer);

public:
	CCard* GetQuizCard() const { return m_pQuizCard; }
	CCard* GetExampleCard(int nIndex) const;
	LPCTSTR GetExampleWord(int nIndex) const;
	CString GetExampleParsedWord(int nIndex) const;	// [ȯ]   ,, и ܾ  1 մϴ.
	int GetExampleParsedWordIndex(int nIndex) const; // [ȯ] ־ ī ε    ° word ȯѴ.
	bool IsWrightAnswer(UINT uiIndex) const
	{
		return (m_uiWrightAnswer == uiIndex);
	}

	BOOL IsCorret() const
	{
		return m_bCorrect;
	}
};



typedef CArray <CQuiz*, CQuiz*> QUIZ_ARRAY;

class CQuizList  
{
private:
	QUIZ_ARRAY m_arQuiz;

	int m_nQuizIndex; //  Index
	int m_nNumHit;       //  
	int m_nNumAnswered;  //  

public:
	CQuizList();
	virtual ~CQuizList();
	void Clear();
	void GenerateList(CCardSet* pCardSet, CQuizSetting* pQuizSetting);

	// 
	CQuiz* GetQuiz() 
	{ 
		ASSERT(m_nQuizIndex < m_arQuiz.GetSize());
		return m_arQuiz[m_nQuizIndex]; 
	}
	bool MoveToNext();
	// 
	bool AnswerOnQuiz(UINT uiIndex);
	int GetNumQuiz() const { return m_arQuiz.GetSize(); }
	int GetQuizIndex() const { return m_nQuizIndex; }
	int GetNumAnswered() const { return m_nNumAnswered; }
	int GetNumHit() const{ return m_nNumHit; }
};


#endif // !defined(AFX_QUIZ_H__538D0B20_F5E4_42D2_9CEF_24DCD1B03BEA__INCLUDED_)
