// Stroke.h: interface for the CStroke class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_STROKE_H__F1ED602D_515B_4A50_A86B_4E08F5FB2192__INCLUDED_)
#define AFX_STROKE_H__F1ED602D_515B_4A50_A86B_4E08F5FB2192__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CStroke  
{
private:
	CArray<CPoint,CPoint>  m_arPoint; 
	CRect m_rcBound;
public:
	CStroke();
	virtual ~CStroke();

	void Draw(CDC* pDC) const;
	void Finish();
	void AddPoint(CPoint* pPoint);
	CRect& GetBoundRect()
	{
		return m_rcBound;
	}
	int GetNumStroke() const
	{
		return m_arPoint.GetSize();
	}
};

class CStrokeList
{
private:
	CList <CStroke*, CStroke*> m_lstStroke;
public:
	CStrokeList();
	virtual ~CStrokeList();

	void Draw(CDC* pDC) const;
	void Clear();
	CRect Undo();
	void StartStroke();
	void EndStroke();
	void AddPoint(CPoint* pPoint);
};

#endif // !defined(AFX_STROKE_H__F1ED602D_515B_4A50_A86B_4E08F5FB2192__INCLUDED_)
