// TemplateSetupDlg.cpp : implementation file
//
#include "stdafx.h"
#include "define.h"
#include "resource.h"
#include "TemplateSetupDlg.h"
#include "Template.h"
#include "ItemNameDlg.h"
#include "Utils.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define SAMPLE_VIEW_HEIGHT 80
#define SAMPLE_VIEW_GAP    4

/////////////////////////////////////////////////////////////////////////////
// CTemplateSetupDlg dialog


CTemplateSetupDlg::CTemplateSetupDlg(CTemplate* pTemplate, CWnd* pParent /*=NULL*/)
	: CDialog(CTemplateSetupDlg::IDD, pParent)
{
	ASSERT(pTemplate != NULL);
	//{{AFX_DATA_INIT(CTemplateSetupDlg)
	m_uiUpperMargin = 0;
	m_uiFontSize = 0;
	//}}AFX_DATA_INIT
	m_pTemplate = pTemplate;
	m_bFontMod = false;
}


void CTemplateSetupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTemplateSetupDlg)
	DDX_Control(pDX, IDC_ITEM_TAB, m_wndItemTab);
	DDX_Control(pDX, IDC_FONT_LIST, m_wndFontList);
	DDX_Control(pDX, IDC_CLEAR_TYPE, m_btnClearType);
	//DDX_Control(pDX, IDC_CHANGE_COLOR, m_btnColor);
	DDX_Control(pDX, IDC_ALIGN, m_wndAlignList);
	DDX_Control(pDX, IDC_ITALIC_CHECK, m_btnItalic);
	DDX_Control(pDX, IDC_BOLD_CHECK, m_btnBold);
	DDX_Control(pDX, IDC_SHOW_IN_QUESTION, m_btnShowInQuestion);
	DDX_Control(pDX, IDC_SHOW_IN_ANSWER, m_btnShowInAnswer);
	DDX_Text(pDX, IDC_UPPER_MARGIN, m_uiUpperMargin);
	DDX_Text(pDX, IDC_FONT_SIZE, m_uiFontSize);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTemplateSetupDlg, CDialog)
	//{{AFX_MSG_MAP(CTemplateSetupDlg)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_CHANGE_NAME, OnChangeName)
	ON_BN_CLICKED(IDC_SHOW_IN_QUESTION, OnShowInQuestion)
	ON_BN_CLICKED(IDC_SHOW_IN_ANSWER, OnShowInAnswer)
	ON_BN_CLICKED(IDC_BOLD_CHECK, OnBoldCheck)
	ON_BN_CLICKED(IDC_ITALIC_CHECK, OnItalicCheck)
	ON_CBN_SELCHANGE(IDC_ALIGN, OnSelchangeAlign)
	ON_EN_CHANGE(IDC_FONT_SIZE, OnChangeFontSize)
	ON_EN_CHANGE(IDC_UPPER_MARGIN, OnChangeUpperMargin)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_CLEAR_TYPE, OnClearType)
	ON_BN_CLICKED(IDC_IMPORT_TEMPLATE, OnImportTemplate)
	ON_BN_CLICKED(IDC_EXPORT_TEMPLATE, OnExportTemplate)
	ON_CBN_SELCHANGE(IDC_FONT_LIST, OnSelchangeFontList)
	ON_NOTIFY(TCN_SELCHANGE, IDC_ITEM_TAB, OnSelchangeItemTab)
	//ON_MESSAGE(CPN_SELENDOK, OnSelEndOK)
	ON_BN_CLICKED(IDC_CHANGE_COLOR, OnChangeColor)
	//}}AFX_MSG_MAP
	//ON_MESSAGE(CPN_SELENDOK, OnSelEndOK)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTemplateSetupDlg message handlers
void CTemplateSetupDlg::OnOK()
{
	/*
	if (m_wndNameEdit.IsWindowVisible())
	{
		//Է Ϸ  
		CString strName;
		m_wndNameEdit.GetWindowText(strName);
		if (strName.GetLength() == 0)
		{
			CString strMsg;
			strMsg.LoadString(IDS_ENTER_ITEM_NAME);
			MessageBox(strMsg, AfxGetAppName(), MB_OK | MB_ICONERROR);
			return;
		}

		if (strName.GetLength() > MAX_ITEM_NAME -1 )
		{
			CString strMsg;
			strMsg.LoadString(IDS_TOO_LONG_ITEM_NAME);
			MessageBox(strMsg, AfxGetAppName(), MB_OK | MB_ICONERROR);
			return;
		}
		int nIndex = m_wndItemTab.GetCurSel();
		m_pTemplate->SetItemName(nIndex, strName);
	}
	*/

	CDialog::OnOK();
}

void CTemplateSetupDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	CString strMsg;
	strMsg.LoadString(IDS_TEMPLATE_SETTING);
	::PaintHeader(dc, strMsg);

	//Sample Display
	if (m_wndItemTab.GetSafeHwnd() != NULL)
	{
		int nIndex = m_wndItemTab.GetCurSel();
		if (nIndex != -1)
		{
			CRect rcClient;
			GetClientRect(rcClient);

			CRect rcSample;
			rcSample.left = rcClient.left + SAMPLE_VIEW_GAP;
			rcSample.right = rcClient.right - SAMPLE_VIEW_GAP;
			//rcSample.bottom = rcClient.bottom - SAMPLE_VIEW_GAP;
			//SIP ½ Client  Ǿ ǥ Ŵ 
			rcSample.bottom = 264;
			rcSample.top = rcSample.bottom - SAMPLE_VIEW_HEIGHT;
			CBrush brBlack;
			brBlack.CreateSolidBrush(RGB(0, 0, 0));
			dc.FrameRect(rcSample, &brBlack);
			CFont* pOldFont = dc.SelectObject(&m_fntSample);
			int nOldMode = dc.SetBkMode(TRANSPARENT);
			COLORREF crOldText = dc.SetTextColor(m_pTemplate->GetFontColor(nIndex));
			CString strSample;
			strSample.LoadString(IDS_SAMPLE_STRING);
			dc.DrawText(strSample, rcSample, 
				DEFAULT_FORMAT | m_pTemplate->GetAlign(nIndex));

			dc.SetBkMode(nOldMode);
			dc.SetTextColor(crOldText);
			dc.SelectObject(&pOldFont);
		}
	}
}

void CTemplateSetupDlg::InitFont(int nIndex)
{
	if (m_fntSample.GetSafeHandle() != NULL)
		m_fntSample.DeleteObject();

	LOGFONT lf;
	memset(&lf, 0, sizeof(LOGFONT));
	lstrcpy(lf.lfFaceName, DEFAULT_FONT); 
	lf.lfHeight = m_pTemplate->GetFontSize(nIndex) * 10;
	lf.lfItalic = m_pTemplate->IsItalicFont(nIndex);
	if (m_pTemplate->IsClearTypeFont(nIndex))
		lf.lfQuality = CLEARTYPE_QUALITY;
	else
		lf.lfQuality = DEFAULT_QUALITY;
	if (m_pTemplate->IsBoldFont(nIndex))
		lf.lfWeight = FW_BOLD;
	m_fntSample.CreatePointFontIndirect(&lf);
}

void CTemplateSetupDlg::UpdateSampleView()
{
	CRect rcClient;
	GetClientRect(rcClient);
	
	rcClient.left = rcClient.left + SAMPLE_VIEW_GAP;
	rcClient.right = rcClient.right - SAMPLE_VIEW_GAP;
	rcClient.bottom = rcClient.bottom - SAMPLE_VIEW_GAP;
	rcClient.top = rcClient.bottom - SAMPLE_VIEW_HEIGHT;

	InvalidateRect(rcClient);
}

static int __stdcall enumfonts(const ENUMLOGFONT *lf,const TEXTMETRIC *tm,
		     int type,LPARAM lp)
{
	HWND cb=(HWND)lp;
	//if (lf->elfLogFont.lfCharSet==ANSI_CHARSET) 
	{
		const TCHAR *fn=lf->elfLogFont.lfFaceName;
		LRESULT ret=::SendMessage(cb,CB_ADDSTRING,0,(LPARAM)fn);
		ASSERT(ret!=CB_ERR && ret!=CB_ERRSPACE);
		ret = ::SendMessage(cb, CB_SETITEMDATA, (WPARAM)ret, 
			(LPARAM)lf->elfLogFont.lfCharSet);
		ASSERT(ret!=CB_ERR);
	}
	return TRUE;
}

BOOL CTemplateSetupDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SendDlgItemMessage(IDC_SIZESPIN,UDM_SETRANGE,0,MAKELONG(50, 7));
	SendDlgItemMessage(IDC_MARGINSPIN,UDM_SETRANGE,0,MAKELONG(50,0));

	//List ߰ 
	for (int i = 0; i < MAX_ITEM; i++)
	{
		m_wndItemTab.InsertItem(i, m_pTemplate->GetItemName(i));
	}
	m_wndItemTab.SetCurSel(0);

	//Font List ߰ 
	// populate font families
	{
		CClientDC dc(this);
		HWND hCB;
		GetDlgItem(IDC_FONT_LIST,&hCB);
		EnumFontFamilies(dc.m_hAttribDC, NULL,(FONTENUMPROC)enumfonts,(LPARAM)hCB);
	}

	SelectCurrentFont(0);

	CString strBtnName;
	strBtnName.LoadString(IDS_COLOR_BUTTON);
	//m_btnColor.SetDefaultText(strBtnName);
	//m_btnColor.SetSelectionMode(CP_MODE_TEXT);

	UpdateDlgItem(0);
	InitFont(0);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


/*
void CTemplateSetupDlg::OnSelchangeItemList() 
{
	int nIndex = m_wndItemTab.GetCurSel();
	if (nIndex >= 0)
	{
		UpdateDlgItem(nIndex);
		InitFont(nIndex);
		UpdateSampleView();
	}
}
*/

void CTemplateSetupDlg::UpdateDlgItem(UINT uiIndex)
{
	m_btnShowInAnswer.SetCheck(
		m_pTemplate->IsShowInAnswer(uiIndex) == TRUE);
	m_btnShowInQuestion.SetCheck(
		m_pTemplate->IsShowInQuestion(uiIndex) == TRUE);
	m_btnBold.SetCheck(
		m_pTemplate->IsBoldFont(uiIndex) == TRUE);
	m_btnItalic.SetCheck(
		m_pTemplate->IsItalicFont(uiIndex) == TRUE);
	m_btnClearType.SetCheck(
		m_pTemplate->IsClearTypeFont(uiIndex) == TRUE);

	m_uiFontSize = m_pTemplate->GetFontSize(uiIndex);
	m_uiUpperMargin = m_pTemplate->GetUpperMargin(uiIndex);

	UINT uiAlign = m_pTemplate->GetAlign(uiIndex);
	if (uiAlign == DT_LEFT)
		m_wndAlignList.SetCurSel(0);
	else if (uiAlign == DT_RIGHT)
		m_wndAlignList.SetCurSel(1);
	else
		m_wndAlignList.SetCurSel(2);

	//m_btnColor.SetColour(m_pTemplate->GetFontColor(uiIndex));

	SelectCurrentFont(uiIndex);

	UpdateData(FALSE);
}


void CTemplateSetupDlg::OnChangeName() 
{
	int nIndex = m_wndItemTab.GetCurSel();

	if (nIndex != -1)
	{
		CItemNameDlg dlgItemName;
		dlgItemName.m_strName = m_pTemplate->GetItemName(nIndex);
		if (IDOK == dlgItemName.DoModal())
		{
			TCHAR szItemName[MAX_ITEM_NAME];
			lstrcpy(szItemName, dlgItemName.m_strName);
			m_pTemplate->SetItemName(nIndex, dlgItemName.m_strName);
			TCITEM tcItem;
			tcItem.mask = TCIF_TEXT;
			tcItem.pszText = szItemName;
			m_wndItemTab.SetItem(nIndex, &tcItem);
		}
	}
	/*
	if (m_wndNameEdit.IsWindowVisible())
	{
		//Է Ϸ  
		CString strName;
		m_wndNameEdit.GetWindowText(strName);
		if (strName.GetLength() == 0)
		{
			CString strMsg;
			strMsg.LoadString(IDS_ENTER_ITEM_NAME);
			MessageBox(strMsg, AfxGetAppName(), MB_OK | MB_ICONERROR);
			return;
		}

		if (strName.GetLength() > MAX_ITEM_NAME -1 )
		{
			CString strMsg;
			strMsg.LoadString(IDS_TOO_LONG_ITEM_NAME);
			MessageBox(strMsg, AfxGetAppName(), MB_OK | MB_ICONERROR);
			return;
		}


		m_wndNameEdit.ShowWindow(SW_HIDE);
		m_wndItemTab.ShowWindow(SW_SHOW);

		int nIndex = m_wndItemTab.GetCurSel();
		m_wndItemTab.InsertString(nIndex, strName);
		m_wndItemTab.DeleteString(nIndex + 1);
		m_wndItemTab.SetCurSel(nIndex);

		m_pTemplate->SetItemName(nIndex, strName);

		CWnd* pWnd = GetDlgItem(IDC_CHANGE_NAME);
		CString strBtnName;
		strBtnName.LoadString(IDS_CHANGE_NAME);
		pWnd->SetWindowText(strBtnName);

#ifdef _WIN32_WCE_PSPC
		SHSipPreference(GetSafeHwnd(), SIP_DOWN);
#endif
	}
	else
	{
		//̸ â  ʴ   
		m_wndNameEdit.ShowWindow(SW_SHOW);
		m_wndItemTab.ShowWindow(SW_HIDE);
		int nIndex = m_wndItemTab.GetCurSel();
		CString strName;
		m_wndItemTab.GetLBText(nIndex, strName);
		m_wndNameEdit.SetWindowText(strName);
		m_wndNameEdit.SetSel(0, -1);
		m_wndNameEdit.SetFocus();

		CWnd* pWnd = GetDlgItem(IDC_CHANGE_NAME);
		CString strBtnName;
		strBtnName.LoadString(IDS_CHANGE_COMPLETE);
		pWnd->SetWindowText(strBtnName);
#ifdef _WIN32_WCE_PSPC
		SHSipPreference(GetSafeHwnd(), SIP_UP);
#endif
	}
	*/
}

void CTemplateSetupDlg::OnShowInQuestion() 
{
	int nIndex = m_wndItemTab.GetCurSel();

	if (nIndex != -1)
	{
		bool bShow;
		if (m_btnShowInQuestion.GetCheck() == BST_CHECKED)
			bShow = true;
		else
			bShow = false;
		m_pTemplate->SetShowInQuestion(nIndex, bShow);
	}
}

void CTemplateSetupDlg::OnShowInAnswer() 
{
	int nIndex = m_wndItemTab.GetCurSel();

	if (nIndex != -1)
	{
		bool bShow;
		if (m_btnShowInAnswer.GetCheck() == BST_CHECKED)
			bShow = true;
		else
			bShow = false;
		m_pTemplate->SetShowInAnswer(nIndex, bShow);
	}
}

void CTemplateSetupDlg::OnBoldCheck() 
{
	int nIndex = m_wndItemTab.GetCurSel();

	if (nIndex != -1)
	{
		bool bBold;
		if (m_btnBold.GetCheck() == BST_CHECKED)
			bBold = true;
		else
			bBold = false;
		m_pTemplate->SetBoldFont(nIndex, bBold);
		m_bFontMod = true;
		InitFont(nIndex);
		UpdateSampleView();
	}
}

void CTemplateSetupDlg::OnItalicCheck() 
{
	int nIndex = m_wndItemTab.GetCurSel();

	if (nIndex != -1)
	{
		bool bItalic;
		if (m_btnItalic.GetCheck() == BST_CHECKED)
			bItalic = true;
		else
			bItalic = false;
		m_pTemplate->SetItalicFont(nIndex, bItalic);
		m_bFontMod = true;
		InitFont(nIndex);
		UpdateSampleView();
	}	
}

void CTemplateSetupDlg::OnSelchangeAlign() 
{
	int nIndex = m_wndItemTab.GetCurSel();

	if (nIndex != -1)
	{
		int nAlign = m_wndAlignList.GetCurSel();

		if (nAlign == 0)
		{
			m_pTemplate->SetAlign(nIndex, DT_LEFT);
		}
		else if (nAlign == 1)
		{
			m_pTemplate->SetAlign(nIndex, DT_RIGHT);
		}
		else
		{
			m_pTemplate->SetAlign(nIndex, DT_CENTER);
		}
		UpdateSampleView();
	}
}

/*
LRESULT CTemplateSetupDlg::OnSelEndOK(WPARAM wParam, LPARAM lParam)
{	
	int nIndex = m_wndItemTab.GetCurSel();

	if (nIndex != -1)
	{
		COLORREF crText;	

		crText = m_btnColor.GetColour();	
		m_pTemplate->SetFontColor(nIndex , crText);
		UpdateSampleView();
		return TRUE;
	}
	return FALSE;
}
*/

void CTemplateSetupDlg::OnChangeColor() 
{
	int nIndex = m_wndItemTab.GetCurSel();

	if (nIndex != CB_ERR)
	{
		//CWinApp* pApp = AfxGetApp();
		CHOOSECOLOR cc;
		static COLORREF acrCustClr[16]; // array of custom colors 

		// Initialize CHOOSECOLOR 
		ZeroMemory(&cc, sizeof(cc));
		cc.lStructSize = sizeof(cc);
		cc.hwndOwner = GetSafeHwnd();
		cc.lpCustColors = (LPDWORD) acrCustClr;
		cc.rgbResult = m_pTemplate->GetFontColor(nIndex);
		cc.Flags = CC_SOLIDCOLOR | CC_RGBINIT;
		
		if (::ChooseColor(&cc) == TRUE)
		{
			m_pTemplate->SetFontColor(nIndex , cc.rgbResult);
			UpdateSampleView();
		}
	}
}


void CTemplateSetupDlg::OnChangeFontSize() 
{
	if (m_wndItemTab.GetSafeHwnd() != NULL)
	{
		int nIndex = m_wndItemTab.GetCurSel();

		if (nIndex != -1)
		{
			UpdateData(TRUE);
			m_pTemplate->SetFontSize(nIndex, m_uiFontSize);
			m_bFontMod = true;
			InitFont(nIndex);
			UpdateSampleView();
		}
	}
}

void CTemplateSetupDlg::OnChangeUpperMargin() 
{
	if (m_wndItemTab.GetSafeHwnd() != NULL)
	{
		int nIndex = m_wndItemTab.GetCurSel();

		if (nIndex != -1)
		{
			UpdateData(TRUE);
			m_pTemplate->SetUpperMargin(nIndex, m_uiUpperMargin);
		}
	}
}

void CTemplateSetupDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	m_fntSample.DeleteObject();	
}



void CTemplateSetupDlg::OnClearType() 
{
	int nIndex = m_wndItemTab.GetCurSel();

	if (nIndex != CB_ERR)
	{
		bool bClearType;
		if (m_btnClearType.GetCheck() == BST_CHECKED)
			bClearType = true;
		else
			bClearType = false;
		m_pTemplate->SetClearTypeFont(nIndex, bClearType);
		m_bFontMod = true;
		InitFont(nIndex);
		UpdateSampleView();
	}	
}


void CTemplateSetupDlg::OnImportTemplate() 
{
	static TCHAR szFilters[]= _T("Template Files (*.mkt)|*.mkt|All Files (*.*)|*.*||");

	CFileDialog dlgOpenFile(
		TRUE, 
		_T("mkt"), 
		_T("*.mkt"), 
		OFN_HIDEREADONLY | OFN_FILEMUSTEXIST, 
		szFilters, this);

	if( dlgOpenFile.DoModal ()==IDOK )
	{
		m_pTemplate->ImportFromFile(dlgOpenFile.GetPathName());
		m_bFontMod = true;
			
		m_wndItemTab.DeleteAllItems();

		//!To do : Ʒ κ Լ и 
		//List ߰ 
		for (int i = 0; i < MAX_ITEM; i++)
		{
			m_wndItemTab.InsertItem(i, m_pTemplate->GetItemName(i));
		}
		m_wndItemTab.SetCurSel(0);

		UpdateDlgItem(0);
		InitFont(0);

		InvalidateRect(NULL, TRUE);
	}
}

void CTemplateSetupDlg::OnExportTemplate() 
{
	static TCHAR szFilters[]= _T("Template Files (*.mkt)|*.mkt|All Files (*.*)|*.*||");

	CFileDialog dlgOpenFile(
		FALSE, 
		_T("mkt"), 
		_T("*.mkt"), 
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
		szFilters, this);

	if( dlgOpenFile.DoModal ()==IDOK )
	{
		m_pTemplate->ExportToFile(dlgOpenFile.GetPathName());
	}
}

void CTemplateSetupDlg::SelectCurrentFont(UINT uiIndex)
{
	LPCTSTR szFontName = m_pTemplate->GetFontName(uiIndex);
	if (szFontName == NULL || lstrlen(szFontName) == 0)
		szFontName = DEFAULT_FONT;
	
	int nNumFont = m_wndFontList.GetCount();

	CString strListText;
	for (int i = 0; i < nNumFont; i++)
	{
		m_wndFontList.GetLBText(i, strListText);	
		if (lstrcmpi(szFontName, strListText) == 0)
		{
			m_wndFontList.SetCurSel(i);
			break;
		}
	}
}

void CTemplateSetupDlg::OnSelchangeFontList() 
{
	int nItemIndex = m_wndItemTab.GetCurSel();

	if (nItemIndex != CB_ERR)
	{
		int nFontIndex = m_wndFontList.GetCurSel();

		if (nFontIndex != CB_ERR)
		{
			CString strListText;
			m_wndFontList.GetLBText(nFontIndex, strListText);
			DWORD dwCharSet = m_wndFontList.GetItemData(nFontIndex);
			m_pTemplate->SetFontName(nItemIndex, strListText, dwCharSet);
			UpdateSampleView();
		}
	}
}

void CTemplateSetupDlg::OnSelchangeItemTab(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int nIndex = m_wndItemTab.GetCurSel();
	if (nIndex >= 0)
	{
		UpdateDlgItem(nIndex);
		InitFont(nIndex);
		UpdateSampleView();
	}
	
	*pResult = 0;
}

