#include "stdafx.h"
#include "Utils.h"

void PaintHeader(CDC &dc, const CString &strTitle)
{
	int nWidth = dc.GetDeviceCaps(HORZRES);
	const int nHeaderHeight = 24;

	// paint title
	CFont *pCurrentFont = dc.GetCurrentFont();
	LOGFONT lf;
	pCurrentFont->GetLogFont(&lf);
	lf.lfWeight = FW_BOLD;
	CFont newFont;
	newFont.CreateFontIndirect(&lf);

	CFont *pSave = dc.SelectObject(&newFont);
	dc.SetTextColor(RGB(0, 0, 156));
	dc.DrawText(strTitle, CRect(8, 0, nWidth, nHeaderHeight), DT_VCENTER | DT_SINGLELINE);
	dc.SelectObject(pSave);

	// paint line
	CPen blackPen(PS_SOLID, 1, RGB(0,0,0));
	CPen *pOldPen = dc.SelectObject(&blackPen);

	dc.MoveTo(0, nHeaderHeight);
	dc.LineTo(nWidth, nHeaderHeight);

	dc.SelectObject(pOldPen);	
}

int DrawMultiLineString(CDC* pDC, LPCTSTR szText, LPRECT lpRect, UINT uiFormat)
{
	int nTotHeight = 0;

	int nWidth = lpRect->right - lpRect->left;

	if (pDC->GetTextExtent(szText).cx < nWidth)
	{
		nTotHeight = pDC->DrawText(szText, lpRect, uiFormat);
	}
	else
	{
		CString strText = szText;
		int nLength = strText.GetLength();
		int nPos = 0;

		for (int nCount = 0; nCount < nLength; nCount++)
		{
			if (pDC->GetTextExtent(strText.Left(nPos)).cx > nWidth) // Ѵ 
			{
				int nHeight = pDC->DrawText(strText.Left( nPos - 1 ), 
					lpRect, uiFormat);
				strText = strText.Mid(nPos - 1);
				nPos = 0;
				lpRect->top += nHeight;
				lpRect->bottom += nHeight;
				nTotHeight += nHeight;
			}
			nPos++;
		}
		nTotHeight += pDC->DrawText(strText, lpRect, uiFormat);
	}
	return nTotHeight;
}

int DrawTextEndEllipsis(CDC* pDC, const CString &strText, LPRECT lpRect, UINT uFormat)
{
	int nWidth = lpRect->right - lpRect->left;

	if(pDC->GetTextExtent(strText).cx > nWidth)
	{
		// Text doesn't fit in rect. We have to truncate it and add ellipsis to the end.
		CString strTemp = strText;

		for(int i=strText.GetLength(); i>=0; i--)
		{
			strTemp = strText.Left(i) + _T("...");
			if(pDC->GetTextExtent(strTemp).cx < nWidth)
			{
				// Gotcha!
				break;
			}
		}
		return pDC->DrawText(strTemp, lpRect, uFormat);
	}
	return pDC->DrawText(strText, lpRect, uFormat);
}

BOOL IsFileExist(LPCTSTR szFileName)
{
	DWORD dwAttribute = GetFileAttributes(szFileName);
	if (dwAttribute == -1)
		return FALSE;
	else
	{
		return TRUE;
	}
}